Unit gavrdefs; { Generated by ana_inc }

Interface

{ define a device type from its name }
Function DefDevice(sDevice:String):Integer;

{ define a device type from its usual include file }
Function InclDevice(sInclFile:String):Integer;

Implementation

Uses SysUtils,gavrsymb,gavrtype,gavriset;

Type
  TDevice = Record { Device definition }
    ndi:Byte; { device number }
    sdn:String[10]; { device name }
    sif:String[10]; { include file name }
    idr:LongInt; { last ram adress RAMEND }
    idx:LongInt; { last external ram address XRAMEND }
    ide:LongInt; { last E2END }
    idp:LongInt; { last EEPROM address }
    idf:LongInt; { last flash address FLASHEND }
    End;
  TSymbol = Record { Symbol definition }
    ssn:String[20];
    isi:LongInt;
    End;
  TRegister = Record { Register definition }
    srn:String;
    iri:LongInt;
    End;

Const

  nDevices = 52;
  aDevices:Array[1..nDevices] Of TDevice = (
    (ndi:1;sdn:'AT90S1200';sif:'1200';idr:-1;idx:0;ide:63;idp:-1;idf:511),
    (ndi:2;sdn:'AT90S2313';sif:'2313';idr:223;idx:223;ide:127;idp:-1;idf:1023),
    (ndi:3;sdn:'AT90S2323';sif:'2323';idr:223;idx:223;ide:127;idp:-1;idf:1023),
    (ndi:4;sdn:'AT90S2333';sif:'2333';idr:223;idx:223;ide:127;idp:-1;idf:1023),
    (ndi:5;sdn:'AT90S2343';sif:'2343';idr:223;idx:223;ide:127;idp:-1;idf:1023),
    (ndi:6;sdn:'AT90S4414';sif:'4414';idr:351;idx:65535;ide:255;idp:-1;idf:2047),
    (ndi:7;sdn:'AT90S4433';sif:'4433';idr:223;idx:223;ide:255;idp:-1;idf:2047),
    (ndi:8;sdn:'AT90S4434';sif:'4434';idr:351;idx:351;ide:255;idp:-1;idf:2047),
    (ndi:9;sdn:'AT90S8515';sif:'8515';idr:607;idx:65535;ide:511;idp:-1;idf:4095),
    (ndi:10;sdn:'AT90C8534';sif:'8534';idr:351;idx:351;ide:511;idp:-1;idf:4095),
    (ndi:11;sdn:'AT90S8535';sif:'8535';idr:607;idx:607;ide:511;idp:-1;idf:4095),
    (ndi:12;sdn:'ATTINY11';sif:'TN11';idr:-1;idx:-1;ide:-1;idp:-1;idf:511),
    (ndi:13;sdn:'ATTINY12';sif:'TN12';idr:-1;idx:-1;ide:63;idp:-1;idf:511),
    (ndi:14;sdn:'ATTINY13';sif:'TN13';idr:159;idx:0;ide:63;idp:-1;idf:511),
    (ndi:15;sdn:'ATTINY15';sif:'TN15';idr:0;idx:0;ide:63;idp:-1;idf:511),
    (ndi:16;sdn:'ATTINY22';sif:'TN22';idr:223;idx:223;ide:127;idp:-1;idf:1023),
    (ndi:17;sdn:'ATTINY25';sif:'TN25';idr:223;idx:0;ide:127;idp:-1;idf:1023),
    (ndi:18;sdn:'ATTINY26';sif:'TN26';idr:223;idx:-1;ide:-1;idp:-1;idf:-1),
    (ndi:19;sdn:'ATTINY28';sif:'TN28';idr:1023;idx:-1;ide:-1;idp:-1;idf:2047),
    (ndi:20;sdn:'ATTINY45';sif:'TN45';idr:351;idx:0;ide:255;idp:-1;idf:2047),
    (ndi:21;sdn:'ATTINY85';sif:'TN85';idr:607;idx:0;ide:511;idp:-1;idf:4095),
    (ndi:22;sdn:'ATTINY2313';sif:'TN2313';idr:223;idx:223;ide:127;idp:-1;idf:1023),
    (ndi:23;sdn:'ATMEGA103';sif:'M103';idr:4095;idx:65535;ide:4095;idp:-1;idf:65535),
    (ndi:24;sdn:'ATMEGA104';sif:'M104';idr:4351;idx:-1;ide:-1;idp:4095;idf:65535),
    (ndi:25;sdn:'ATMEGA1280';sif:'M1280';idr:8703;idx:-1;ide:-1;idp:-1;idf:65535),
    (ndi:26;sdn:'ATMEGA1281';sif:'M1281';idr:8703;idx:-1;ide:-1;idp:-1;idf:65535),
    (ndi:27;sdn:'ATMEGA128';sif:'M128';idr:4351;idx:-1;ide:-1;idp:4095;idf:65535),
    (ndi:28;sdn:'ATMEGA161';sif:'M161';idr:1119;idx:65535;ide:511;idp:-1;idf:8191),
    (ndi:29;sdn:'ATMEGA162';sif:'M162';idr:1160;idx:-1;ide:-1;idp:511;idf:8191),
    (ndi:30;sdn:'ATMEGA163';sif:'M163';idr:1119;idx:-1;ide:511;idp:-1;idf:8191),
    (ndi:31;sdn:'ATMEGA165';sif:'M165';idr:1279;idx:-1;ide:-1;idp:-1;idf:8191),
    (ndi:32;sdn:'ATMEGA168';sif:'M168';idr:1279;idx:-1;ide:-1;idp:-1;idf:8191),
    (ndi:33;sdn:'ATMEGA169';sif:'M169';idr:1279;idx:-1;ide:-1;idp:511;idf:8191),
    (ndi:34;sdn:'ATMEGA16';sif:'M16';idr:1119;idx:-1;ide:-1;idp:-1;idf:8191),
    (ndi:35;sdn:'ATMEGA2560';sif:'M2560';idr:8703;idx:-1;ide:-1;idp:-1;idf:131071),
    (ndi:36;sdn:'ATMEGA2561';sif:'M2561';idr:8703;idx:-1;ide:-1;idp:-1;idf:131071),
    (ndi:37;sdn:'ATMEGA323';sif:'M323';idr:2143;idx:-1;ide:1023;idp:-1;idf:16383),
    (ndi:38;sdn:'ATMEGA3250';sif:'M3250';idr:2303;idx:-1;ide:1023;idp:-1;idf:16383),
    (ndi:39;sdn:'ATMEGA325';sif:'M325';idr:2303;idx:-1;ide:1023;idp:-1;idf:16383),
    (ndi:40;sdn:'ATMEGA32';sif:'M32';idr:2143;idx:-1;ide:1023;idp:-1;idf:16383),
    (ndi:41;sdn:'ATMEGA48';sif:'M48';idr:607;idx:-1;ide:-1;idp:-1;idf:4095),
    (ndi:42;sdn:'ATMEGA603';sif:'M603';idr:4095;idx:65535;ide:2047;idp:-1;idf:32767),
    (ndi:43;sdn:'ATMEGA640';sif:'M640';idr:8703;idx:-1;ide:-1;idp:-1;idf:32767),
    (ndi:44;sdn:'ATMEGA6450';sif:'M6450';idr:4351;idx:-1;ide:2047;idp:-1;idf:32767),
    (ndi:45;sdn:'ATMEGA645';sif:'M645';idr:4351;idx:-1;ide:2047;idp:-1;idf:32767),
    (ndi:46;sdn:'ATMEGA64';sif:'M64';idr:4351;idx:-1;ide:-1;idp:2047;idf:32767),
    (ndi:47;sdn:'ATMEGA83';sif:'M83';idr:607;idx:-1;ide:511;idp:-1;idf:8191),
    (ndi:48;sdn:'ATMEGA8515';sif:'M8515';idr:607;idx:-1;ide:-1;idp:511;idf:4095),
    (ndi:49;sdn:'ATMEGA8535';sif:'M8535';idr:607;idx:-1;ide:-1;idp:-1;idf:4095),
    (ndi:50;sdn:'ATMEGA88';sif:'M88';idr:1279;idx:-1;ide:-1;idp:-1;idf:8191),
    (ndi:51;sdn:'ATMEGA8';sif:'M8';idr:1119;idx:-1;ide:-1;idp:-1;idf:4095),
    (ndi:52;sdn:'AT86RF401';sif:'AT86RF401';idr:-1;idx:-1;ide:-1;idp:-1;idf:-1));

  aIntVec:Array[1..nDevices] Of AnsiString = (
  { Interrupt vector definitions for AT90S1200 device }
    'INT0=1;OVF0=2;ACI=3',
  { Interrupt vector definitions for AT90S2313 device }
    'INT0=1;INT1=2;ICP1=3;OC1=4;OVF1=5;OVF0=6;URXC=7;UDRE=8;UTXC=9;ACI=10',
  { Interrupt vector definitions for AT90S2323 device }
    'INT0=1;OVF0=2',
  { Interrupt vector definitions for AT90S2333 device }
    'INT0=1;INT1=2;ICP1=3;OC1A=4;OVF1=5;OVF0=6;SPI=7;URXC=8;UDRE=9;UTXC=10;ADCC=11;ERDY=12;ACI=13',
  { Interrupt vector definitions for AT90S2343 device }
    'INT0=1;OVF0=2',
  { Interrupt vector definitions for AT90S4414 device }
    'INT0=1;INT1=2;ICP1=3;OC1A=4;OC1B=5;OVF1=6;OVF0=7;SPI=8;URXC=9;UDRE=10;UTXC=11;ACI=12',
  { Interrupt vector definitions for AT90S4433 device }
    'INT0=1;INT1=2;ICP1=3;OC1A=4;OVF1=5;OVF0=6;SPI=7;URXC=8;UDRE=9;UTXC=10;ADCC=11;ERDY=12;ACI=13',
  { Interrupt vector definitions for AT90S4434 device }
    'INT0=1;INT1=2;OC2=3;OVF2=4;ICP1=5;OC1A=6;OC1B=7;OVF1=8;OVF0=9;SPI=10;URXC=11;UDRE=12;UTXC=13;ADCC=14;'+
    'ERDY=15;ACI=16',
  { Interrupt vector definitions for AT90S8515 device }
    'INT0=1;INT1=2;ICP1=3;OC1A=4;OC1B=5;OVF1=6;OVF0=7;SPI=8;URXC=9;UDRE=10;UTXC=11;ACI=12',
  { Interrupt vector definitions for AT90C8534 device }
    'INT0=1;INT1=2;OVF1=3;OVF0=4;ADCC=5;ERDY=6',
  { Interrupt vector definitions for AT90S8535 device }
    'INT0=1;INT1=2;OC2=3;OVF2=4;ICP1=5;OC1A=6;OC1B=7;OVF1=8;OVF0=9;SPI=10;URXC=11;UDRE=12;UTXC=13;ADCC=14;'+
    'ERDY=15;ACI=16',
  { Interrupt vector definitions for ATTINY11 device }
    'INT0=1;PCINT=2;OVF0=3;ACI=4',
  { Interrupt vector definitions for ATTINY12 device }
    'INT0=1;PCINT=2;OVF0=3;ERDY=4;ACI=5',
  { Interrupt vector definitions for ATTINY13 device }
    'INT0=1;PCINT0=2;TIM0_OVF=3;EE_RDY=4;ANA_COMP=5;TIM0_COMPA=6;TIM0_COMPB=7;WDT=8;ADC=9',
  { Interrupt vector definitions for ATTINY15 device }
    'INT0=1;PC=2;T1CP=3;T1OV=4;T0OV=5;ERDY=6;AC=7;ADC=8',
  { Interrupt vector definitions for ATTINY22 device }
    'INT0=1;OVF0=2',
  { Interrupt vector definitions for ATTINY25 device }
    'EXT_INT0=1;PCINT0=2;TIM1_COMPA=3;TIM1_OVF=4;TIM0_OVF=5;EE_RDY=6;ANA_COMP=7;ADC=8;TIM1_COMPB=9;TIM0_COMPA=10;'+
    'TIM0_COMPB=11;WDT=12;USI_START=13;USI_OVF=14',
  { Interrupt vector definitions for ATTINY26 device }
    'INT0=1;IOPINS=2;OC1A=3;OC1B=4;OVF1=5;OVF0=6;USI_START=7;USI_OVF=8;ERDY=9;ACI=10;ADCC=11',
  { Interrupt vector definitions for ATTINY28 device }
    'INT0=1;INT1=2;LLINT=3;OVF0=4;ACI=5',
  { Interrupt vector definitions for ATTINY45 device }
    'EXT_INT0=1;PCINT0=2;TIM1_COMPA=3;TIM1_OVF=4;TIM0_OVF=5;EE_RDY=6;ANA_COMP=7;ADC=8;TIM1_COMPB=9;TIM0_COMPA=10;'+
    'TIM0_COMPB=11;WDT=12;USI_START=13;USI_OVF=14',
  { Interrupt vector definitions for ATTINY85 device }
    'EXT_INT0=1;PCINT0=2;TIM1_COMPA=3;TIM1_OVF=4;TIM0_OVF=5;EE_RDY=6;ANA_COMP=7;ADC=8;TIM1_COMPB=9;TIM0_COMPA=10;'+
    'TIM0_COMPB=11;WDT=12;USI_START=13;USI_OVF=14',
  { Interrupt vector definitions for ATTINY2313 device }
    'INT0=1;INT1=2;TIM1CAPT=3;TIM1COMPA=4;TIM1OVF=5;TIM0OVF=6;USART0RXC=7;USART0DRE=8;USART0TXC=9;ANACOMP=10;'+
    'PCINT=11;TIMER1COMPB=12;TIMER1COMPA=13;TIMER0COMPB=14;USISTART=15;USIOVERFLOW=16;EEREADY=17;WDTOVERFLOW=18',
  { Interrupt vector definitions for ATMEGA103 device }
    'INT0=2;INT1=4;INT2=6;INT3=8;INT4=10;INT5=12;INT6=14;INT7=16;OC2=18;OVF2=20;ICP1=22;OC1A=24;OC1B=26;'+
    'OVF1=28;OC0=30;OVF0=32;SPI=34;URXC=36;UDRE=38;UTXC=40;ADCC=42;EEWR=44;ACI=46',
  { Interrupt vector definitions for ATMEGA104 device }
    'INT0=2;INT1=4;INT2=6;INT3=8;INT4=10;INT5=12;INT6=14;INT7=16;OC2=18;OVF2=20;ICP1=22;OC1A=24;OC1B=26;'+
    'OVF1=28;OC0=30;OVF0=32;SPI=34;URXC0=36;UDRE0=38;UTXC0=40;ADCC=42;ERDY=44;ACI=46;OC1C=48;ICP3=50;'+
    'OC3A=52;OC3B=54;OC3C=56;OVF3=58;URXC1=60;UDRE1=62;UTXC1=64;TWI=66;SPMR=68',
  { Interrupt vector definitions for ATMEGA1280 device }
    'INT0=2;INT1=4;INT2=6;INT3=8;INT4=10;INT5=12;INT6=14;INT7=16;PCINT0=18;PCINT1=20;PCINT2=22;WDT=24;'+
    'OC2A=26;OC2B=28;OVF2=30;ICP1=32;OC1A=34;OC1B=36;OC1C=38;OVF1=40;OC0A=42;OC0B=44;OVF0=46;SPI=48;URXC0=50;'+
    'UDRE0=52;UTXC0=54;ACI=56;ADC=58;ERDY=60;ICP3=62;OC3A=64;OC3B=66;OC3C=68;OVF3=70;URXC1=72;UDRE1=74;'+
    'UTXC1=76;TWI=78;SPMR=80;ICP4=82;OC4A=84;OC4B=86;OC4C=88;OVF4=90;ICP5=92;OC5A=94;OC5B=96;OC5C=98;'+
    'OVF5=100;URXC2=102;UDRE2=104;UTXC2=106;URXC3=108;UDRE3=110;UTXC3=112',
  { Interrupt vector definitions for ATMEGA1281 device }
    'INT0=2;INT1=4;INT2=6;INT3=8;INT4=10;INT5=12;INT6=14;INT7=16;PCINT0=18;PCINT1=20;PCINT2=22;WDT=24;'+
    'OC2A=26;OC2B=28;OVF2=30;ICP1=32;OC1A=34;OC1B=36;OC1C=38;OVF1=40;OC0A=42;OC0B=44;OVF0=46;SPI=48;URXC0=50;'+
    'UDRE0=52;UTXC0=54;ACI=56;ADC=58;ERDY=60;ICP3=62;OC3A=64;OC3B=66;OC3C=68;OVF3=70;URXC1=72;UDRE1=74;'+
    'UTXC1=76;TWI=78;SPMR=80;OC4A=84;OC4B=86;OC4C=88;OVF4=90;OC5A=94;OC5B=96;OC5C=98;OVF5=100',
  { Interrupt vector definitions for ATMEGA128 device }
    'INT0=2;INT1=4;INT2=6;INT3=8;INT4=10;INT5=12;INT6=14;INT7=16;OC2=18;OVF2=20;ICP1=22;OC1A=24;OC1B=26;'+
    'OVF1=28;OC0=30;OVF0=32;SPI=34;URXC0=36;UDRE0=38;UTXC0=40;ADCC=42;ERDY=44;ACI=46;OC1C=48;ICP3=50;'+
    'OC3A=52;OC3B=54;OC3C=56;OVF3=58;URXC1=60;UDRE1=62;UTXC1=64;TWI=66;SPMR=68',
  { Interrupt vector definitions for ATMEGA161 device }
    'INT0=2;INT1=4;INT2=6;CMP2=8;OVF2=10;ICP1=12;OC1A=14;OC1B=16;OVF1=18;CMP0=20;OVF0=22;SPI=24;URXC0=26;'+
    'URXC1=28;UDRE0=30;UDRE1=32;UTXC0=34;UTXC1=36;EERDY=38;ACI=40;URXC=26;UDRE=30;UTXC=34',
  { Interrupt vector definitions for ATMEGA162 device }
    'INT0=2;INT1=4;INT2=6;PCINT0=8;PCINT1=10;TIMER3CAPT=12;TIMER3COMPA=14;TIMER3COMPB=16;TIMER3OVF=18;'+
    'TIMER2COMP=20;TIMER2OVF=22;TIMER1CAPT=24;TIMER1COMPA=26;TIMER1COMPB=28;TIMER1OVF=30;TIMER0COMP=32;'+
    'TIMER0OVF=34;SPISTC=36;USART0RXC=38;USART1RXC=40;USART0UDRE=42;USART1UDRE=44;USART0TXC=46;USART1TXC=48;'+
    'EE_RDY=50;ANA_CMP=52;SPM_RDY=54',
  { Interrupt vector definitions for ATMEGA163 device }
    'INT0=2;INT1=4;OC2=6;OVF2=8;ICP1=10;OC1A=12;OC1B=14;OVF1=16;OVF0=18;SPI=20;URXC=22;UDRE=24;UTXC=26;'+
    'ADCC=28;ERDY=30;ACI=32;TWSI=34',
  { Interrupt vector definitions for ATMEGA165 device }
    'INT0=2;PCINT0=4;PCINT1=6;OC2=8;OVF2=10;ICP1=12;OC1A=14;OC1B=16;OVF1=18;OC0=20;OVF0=22;SPI=24;URXC=26;'+
    'UDRE=28;UTXC=30;USIS=32;USIO=34;ACI=36;ADC=38;ERDY=40;SPMR=42',
  { Interrupt vector definitions for ATMEGA168 device }
    'INT0=2;INT1=4;PCINT0=6;PCINT1=8;PCINT2=10;WDTINT=12;OC2A=14;OC2B=16;OVF2=18;ICP1=20;OC1A=22;OC1B=24;'+
    'OVF1=26;OC0A=28;OC0B=30;OVF0=32;SPI=34;URXC=36;UDRE=38;UTXC=40;ADCC=42;ERDY=44;ACI=46;TWI=48;SPM=50;'+
    'SPMR=50',
  { Interrupt vector definitions for ATMEGA169 device }
    'INT0=2;PCINT0=4;PCINT1=6;CMP2=8;OC2=8;OVF2=10;ICP1=12;OC1A=14;OC1B=16;OVF1=18;CMP0=20;OC0=20;OVF0=22;'+
    'SPI=24;URXC0=26;UDRE0=28;UTXC0=30;USI_START=32;USI_OVF=34;ACI=36;ADCC=38;ERDY=40;SPMR=42;LCDSF=44;'+
    'URXC=26;UDRE=30;UTXC=34',
  { Interrupt vector definitions for ATMEGA16 device }
    'INT0=2;INT1=4;OC2=6;OVF2=8;ICP1=10;OC1A=12;OC1B=14;OVF1=16;OVF0=18;SPI=20;URXC=22;UDRE=24;UTXC=26;'+
    'ADCC=28;ERDY=30;ACI=32;TWI=34;INT2=36;OC0=38;SPMR=40',
  { Interrupt vector definitions for ATMEGA2560 device }
    'INT0=2;INT1=4;INT2=6;INT3=8;INT4=10;INT5=12;INT6=14;INT7=16;PCINT0=18;PCINT1=20;PCINT2=22;WDT=24;'+
    'OC2A=26;OC2B=28;OVF2=30;ICP1=32;OC1A=34;OC1B=36;OC1C=38;OVF1=40;OC0A=42;OC0B=44;OVF0=46;SPI=48;URXC0=50;'+
    'UDRE0=52;UTXC0=54;ACI=56;ADC=58;ERDY=60;ICP3=62;OC3A=64;OC3B=66;OC3C=68;OVF3=70;URXC1=72;UDRE1=74;'+
    'UTXC1=76;TWI=78;SPMR=80;ICP4=82;OC4A=84;OC4B=86;OC4C=88;OVF4=90;ICP5=92;OC5A=94;OC5B=96;OC5C=98;'+
    'OVF5=100;URXC2=102;UDRE2=104;UTXC2=106;URXC3=108;UDRE3=110;UTXC3=112',
  { Interrupt vector definitions for ATMEGA2561 device }
    'INT0=2;INT1=4;INT2=6;INT3=8;INT4=10;INT5=12;INT6=14;INT7=16;PCINT0=18;PCINT1=20;PCINT2=22;WDT=24;'+
    'OC2A=26;OC2B=28;OVF2=30;ICP1=32;OC1A=34;OC1B=36;OC1C=38;OVF1=40;OC0A=42;OC0B=44;OVF0=46;SPI=48;URXC0=50;'+
    'UDRE0=52;UTXC0=54;ACI=56;ADC=58;ERDY=60;ICP3=62;OC3A=64;OC3B=66;OC3C=68;OVF3=70;URXC1=72;UDRE1=74;'+
    'UTXC1=76;TWI=78;SPMR=80;OC4A=84;OC4B=86;OC4C=88;OVF4=90;OC5A=94;OC5B=96;OC5C=98;OVF5=100',
  { Interrupt vector definitions for ATMEGA323 device }
    'INT0=2;INT1=4;INT2=6;OC2=8;OVF2=10;ICP1=12;OC1A=14;OC1B=16;OVF1=18;OC0=20;OVF0=22;SPI=24;URXC=26;'+
    'UDRE=28;UTXC=30;ADCC=32;ERDY=34;ACI=36;TWSI=38;SPMR=40',
  { Interrupt vector definitions for ATMEGA3250 device }
    'INT0=2;PCINT0=4;PCINT1=6;TIMER2COMP=8;TIMER2OVF=10;TIMER1CAPT=12;TIMER1COMPA=14;TIMER1COMPB=16;TIMER1OVF=18;'+
    'TIMER0COMP=20;TIMER0OVF=22;SPI=24;URXC=26;UDRE=28;UTXC=30;USISTART=32;USIOVF=34;ANAC=36;ADC=38;EERDY=40;'+
    'SPMR=42;PCINT2=46;PCINT3=48',
  { Interrupt vector definitions for ATMEGA325 device }
    'INT0=2;PCINT0=4;PCINT1=6;TIMER2COMP=8;TIMER2OVF=10;TIMER1CAPT=12;TIMER1COMPA=14;TIMER1COMPB=16;TIMER1OVF=18;'+
    'TIMER0COMP=20;TIMER0OVF=22;SPI=24;URXC=26;UDRE=28;UTXC=30;USISTART=32;USIOVF=34;ANAC=36;ADC=38;EERDY=40;'+
    'SPMR=42;PCINT2=46;PCINT3=48',
  { Interrupt vector definitions for ATMEGA32 device }
    'INT0=2;INT1=4;INT2=6;OC2=8;OVF2=10;ICP1=12;OC1A=14;OC1B=16;OVF1=18;OC0=20;OVF0=22;SPI=24;URXC=26;'+
    'UDRE=28;UTXC=30;ADCC=32;ERDY=34;ACI=36;TWSI=38;SPMR=40',
  { Interrupt vector definitions for ATMEGA48 device }
    'INT0=1;INT1=2;PCINT0=3;PCINT1=4;PCINT2=5;WDTINT=6;OC2A=7;OC2B=8;OVF2=9;ICP1=10;OC1A=11;OC1B=12;OVF1=13;'+
    'OC0A=14;OC0B=15;OVF0=16;SPI=17;URXC=18;UDRE=19;UTXC=20;ADCC=21;ERDY=22;ACI=23;TWI=24;SPM=25;SPMR=25',
  { Interrupt vector definitions for ATMEGA603 device }
    'INT0=2;INT1=4;INT2=6;INT3=8;INT4=10;INT5=12;INT6=14;INT7=16;OC2=18;OVF2=20;ICP1=22;OC1A=24;OC1B=26;'+
    'OVF1=28;OC0=30;OVF0=32;SPI=34;URXC=36;UDRE=38;UTXC=40;ADCC=42;EEWR=44;ACI=46',
  { Interrupt vector definitions for ATMEGA640 device }
    'INT0=2;INT1=4;INT2=6;INT3=8;INT4=10;INT5=12;INT6=14;INT7=16;PCINT0=18;PCINT1=20;PCINT2=22;WDT=24;'+
    'OC2A=26;OC2B=28;OVF2=30;ICP1=32;OC1A=34;OC1B=36;OC1C=38;OVF1=40;OC0A=42;OC0B=44;OVF0=46;SPI=48;URXC0=50;'+
    'UDRE0=52;UTXC0=54;ACI=56;ADC=58;ERDY=60;ICP3=62;OC3A=64;OC3B=66;OC3C=68;OVF3=70;URXC1=72;UDRE1=74;'+
    'UTXC1=76;TWI=78;SPMR=80;ICP4=82;OC4A=84;OC4B=86;OC4C=88;OVF4=90;ICP5=92;OC5A=94;OC5B=96;OC5C=98;'+
    'OVF5=100;URXC2=102;UDRE2=104;UTXC2=106;URXC3=108;UDRE3=110;UTXC3=112',
  { Interrupt vector definitions for ATMEGA6450 device }
    'INT0=2;PCINT0=4;PCINT1=6;TIMER2COMP=8;TIMER2OVF=10;TIMER1CAPT=12;TIMER1COMPA=14;TIMER1COMPB=16;TIMER1OVF=18;'+
    'TIMER0COMP=20;TIMER0OVF=22;SPI=24;URXC=26;UDRE=28;UTXC=30;USISTART=32;USIOVF=34;ANAC=36;ADC=38;EERDY=40;'+
    'SPMR=42;PCINT2=46;PCINT3=48',
  { Interrupt vector definitions for ATMEGA645 device }
    'INT0=2;PCINT0=4;PCINT1=6;TIMER2COMP=8;TIMER2OVF=10;TIMER1CAPT=12;TIMER1COMPA=14;TIMER1COMPB=16;TIMER1OVF=18;'+
    'TIMER0COMP=20;TIMER0OVF=22;SPI=24;URXC=26;UDRE=28;UTXC=30;USISTART=32;USIOVF=34;ANAC=36;ADC=38;EERDY=40;'+
    'SPMR=42;PCINT2=46;PCINT3=48',
  { Interrupt vector definitions for ATMEGA64 device }
    'INT0=2;INT1=4;INT2=6;INT3=8;INT4=10;INT5=12;INT6=14;INT7=16;OC2=18;OVF2=20;ICP1=22;OC1A=24;OC1B=26;'+
    'OVF1=28;OC0=30;OVF0=32;SPI=34;URXC0=36;UDRE0=38;UTXC0=40;ADCC=42;ERDY=44;ACI=46;OC1C=48;ICP3=50;'+
    'OC3A=52;OC3B=54;OC3C=56;OVF3=58;URXC1=60;UDRE1=62;UTXC1=64;I2C=66;TWI=66;SPMR=68',
  { Interrupt vector definitions for ATMEGA83 device }
    'INT0=1;INT1=2;OC2=3;OVF2=4;ICP1=5;OC1A=6;OC1B=7;OVF1=8;OVF0=9;SPI=10;URXC=11;UDRE=12;UTXC=13;ADCC=14;'+
    'ERDY=15;ACI=16;TWSI=17',
  { Interrupt vector definitions for ATMEGA8515 device }
    'INT0=1;INT1=2;ICP1=3;OC1A=4;OC1B=5;OVF1=6;OVF0=7;SPI=8;URXC=9;UDRE=10;UTXC=11;ACI=12;INT2=13;OC0=14;'+
    'ERDY=15;SPM=16;SPMR=16',
  { Interrupt vector definitions for ATMEGA8535 device }
    'INT0=1;INT1=2;OC2=3;OVF2=4;ICP1=5;OC1A=6;OC1B=7;OVF1=8;OVF0=9;SPI=10;URXC=11;UDRE=12;UTXC=13;ADCC=14;'+
    'ERDY=15;ACI=16;TWI=17;I2C=17;INT2=18;OC0=19;SPMR=20',
  { Interrupt vector definitions for ATMEGA88 device }
    'INT0=1;INT1=2;PCINT0=3;PCINT1=4;PCINT2=5;WDTINT=6;OC2A=7;OC2B=8;OVF2=9;ICP1=10;OC1A=11;OC1B=12;OVF1=13;'+
    'OC0A=14;OC0B=15;OVF0=16;SPI=17;URXC=18;UDRE=19;UTXC=20;ADCC=21;ERDY=22;ACI=23;TWI=24;SPM=25;SPMR=25',
  { Interrupt vector definitions for ATMEGA8 device }
    'INT0=1;INT1=2;OC2=3;OVF2=4;ICP1=5;OC1A=6;OC1B=7;OVF1=8;OVF0=9;SPI=10;URXC=11;UDRE=12;UTXC=13;ADCC=14;'+
    'ERDY=15;ACI=16;TWI=17;SPM=18;SPMR=18',
  { Interrupt vector definitions for AT86RF401 device }
    '');

  aSymbols:Array[1..1915] Of TSymbol = (
    (ssn:'SREG';isi:63),(ssn:'GIMSK';isi:59),(ssn:'TIMSK';isi:57),(ssn:'TIFR';isi:56),(ssn:'MCUCR';isi:53),
    (ssn:'TCCR0';isi:51),(ssn:'TCNT0';isi:50),(ssn:'WDTCR';isi:33),(ssn:'EEAR';isi:30),(ssn:'EEDR';isi:29),
    (ssn:'EECR';isi:28),(ssn:'PORTB';isi:24),(ssn:'DDRB';isi:23),(ssn:'PINB';isi:22),(ssn:'PORTD';isi:18),
    (ssn:'DDRD';isi:17),(ssn:'PIND';isi:16),(ssn:'ACSR';isi:8),(ssn:'INT0';isi:6),(ssn:'TOIE0';isi:1),
    (ssn:'TOV0';isi:1),(ssn:'SE';isi:5),(ssn:'SM';isi:4),(ssn:'ISC01';isi:1),(ssn:'ISC00';isi:0),(ssn:'CS02';isi:2),
    (ssn:'CS01';isi:1),(ssn:'CS00';isi:0),(ssn:'WDE';isi:3),(ssn:'WDP2';isi:2),(ssn:'WDP1';isi:1),(ssn:'WDP0';isi:0),
    (ssn:'EEWE';isi:1),(ssn:'EERE';isi:0),(ssn:'PB7';isi:7),(ssn:'PB6';isi:6),(ssn:'PB5';isi:5),(ssn:'PB4';isi:4),
    (ssn:'PB3';isi:3),(ssn:'PB2';isi:2),(ssn:'PB1';isi:1),(ssn:'PB0';isi:0),(ssn:'DDB7';isi:7),(ssn:'DDB6';isi:6),
    (ssn:'DDB5';isi:5),(ssn:'DDB4';isi:4),(ssn:'DDB3';isi:3),(ssn:'DDB2';isi:2),(ssn:'DDB1';isi:1),(ssn:'DDB0';isi:0),
    (ssn:'PINB7';isi:7),(ssn:'PINB6';isi:6),(ssn:'PINB5';isi:5),(ssn:'PINB4';isi:4),(ssn:'PINB3';isi:3),
    (ssn:'PINB2';isi:2),(ssn:'PINB1';isi:1),(ssn:'PINB0';isi:0),(ssn:'PD6';isi:6),(ssn:'PD5';isi:5),(ssn:'PD4';isi:4),
    (ssn:'PD3';isi:3),(ssn:'PD2';isi:2),(ssn:'PD1';isi:1),(ssn:'PD0';isi:0),(ssn:'DDD6';isi:6),(ssn:'DDD5';isi:5),
    (ssn:'DDD4';isi:4),(ssn:'DDD3';isi:3),(ssn:'DDD2';isi:2),(ssn:'DDD1';isi:1),(ssn:'DDD0';isi:0),(ssn:'PIND6';isi:6),
    (ssn:'PIND5';isi:5),(ssn:'PIND4';isi:4),(ssn:'PIND3';isi:3),(ssn:'PIND2';isi:2),(ssn:'PIND1';isi:1),
    (ssn:'PIND0';isi:0),(ssn:'ACD';isi:7),(ssn:'ACO';isi:5),(ssn:'ACI';isi:4),(ssn:'ACIE';isi:3),(ssn:'ACIS1';isi:1),
    (ssn:'ACIS0';isi:0),(ssn:'SPL';isi:61),(ssn:'GIFR';isi:58),(ssn:'TCCR1A';isi:47),(ssn:'TCCR1B';isi:46),
    (ssn:'TCNT1H';isi:45),(ssn:'TCNT1L';isi:44),(ssn:'OCR1AH';isi:43),(ssn:'OCR1AL';isi:42),(ssn:'ICR1H';isi:37),
    (ssn:'ICR1L';isi:36),(ssn:'EEARL';isi:30),(ssn:'UDR';isi:12),(ssn:'USR';isi:11),(ssn:'UCR';isi:10),
    (ssn:'UBRR';isi:9),(ssn:'SP7';isi:7),(ssn:'SP6';isi:6),(ssn:'SP5';isi:5),(ssn:'SP4';isi:4),(ssn:'SP3';isi:3),
    (ssn:'SP2';isi:2),(ssn:'SP1';isi:1),(ssn:'SP0';isi:0),(ssn:'INT1';isi:7),(ssn:'INTF1';isi:7),(ssn:'INTF0';isi:6),
    (ssn:'TOIE1';isi:7),(ssn:'OCIE1A';isi:6),(ssn:'TICIE';isi:3),(ssn:'TOV1';isi:7),(ssn:'OCF1A';isi:6),
    (ssn:'ICF1';isi:3),(ssn:'ISC11';isi:3),(ssn:'ISC10';isi:2),(ssn:'COM1A1';isi:7),(ssn:'COM1A0';isi:6),
    (ssn:'PWM11';isi:1),(ssn:'PWM10';isi:0),(ssn:'ICNC1';isi:7),(ssn:'ICES1';isi:6),(ssn:'CTC1';isi:3),
    (ssn:'CS12';isi:2),(ssn:'CS11';isi:1),(ssn:'CS10';isi:0),(ssn:'WDTOE';isi:4),(ssn:'EEMWE';isi:2),
    (ssn:'RXC';isi:7),(ssn:'TXC';isi:6),(ssn:'UDRE';isi:5),(ssn:'FE';isi:4),(ssn:'OR';isi:3),(ssn:'RXCIE';isi:7),
    (ssn:'TXCIE';isi:6),(ssn:'UDRIE';isi:5),(ssn:'RXEN';isi:4),(ssn:'TXEN';isi:3),(ssn:'CHR9';isi:2),
    (ssn:'RXB8';isi:1),(ssn:'TXB8';isi:0),(ssn:'ACIC';isi:2),(ssn:'MCUSR';isi:52),(ssn:'EXTRF';isi:1),
    (ssn:'PORF';isi:0),(ssn:'SP';isi:61),(ssn:'OCR1H';isi:43),(ssn:'OCR1L';isi:42),(ssn:'ICR1H';isi:39),
    (ssn:'ICR1L';isi:38),(ssn:'PORTC';isi:21),(ssn:'DDRC';isi:20),(ssn:'PINC';isi:19),(ssn:'SPDR';isi:15),
    (ssn:'SPSR';isi:14),(ssn:'SPCR';isi:13),(ssn:'UCSRA';isi:11),(ssn:'UCSRB';isi:10),(ssn:'UBRRL';isi:9),
    (ssn:'ADMUX';isi:7),(ssn:'ADCSR';isi:6),(ssn:'ADCH';isi:5),(ssn:'ADCL';isi:4),(ssn:'UBRRH';isi:3),
    (ssn:'WDRF';isi:3),(ssn:'BORF';isi:2),(ssn:'OCIE1';isi:6),(ssn:'TICIE1';isi:3),(ssn:'OCF1';isi:6),
    (ssn:'COM11';isi:7),(ssn:'COM10';isi:6),(ssn:'EERIE';isi:3),(ssn:'SPIE';isi:7),(ssn:'SPE';isi:6),
    (ssn:'DORD';isi:5),(ssn:'MSTR';isi:4),(ssn:'CPOL';isi:3),(ssn:'CPHA';isi:2),(ssn:'SPR1';isi:1),(ssn:'SPR0';isi:0),
    (ssn:'SPIF';isi:7),(ssn:'WCOL';isi:6),(ssn:'MPCM';isi:0),(ssn:'AINBG';isi:6),(ssn:'ADCBG';isi:6),
    (ssn:'MUX2';isi:2),(ssn:'MUX1';isi:1),(ssn:'MUX0';isi:0),(ssn:'ADEN';isi:7),(ssn:'ADSC';isi:6),(ssn:'ADFR';isi:5),
    (ssn:'ADIF';isi:4),(ssn:'ADIE';isi:3),(ssn:'ADPS2';isi:2),(ssn:'ADPS1';isi:1),(ssn:'ADPS0';isi:0),
    (ssn:'PC5';isi:5),(ssn:'PC4';isi:4),(ssn:'PC3';isi:3),(ssn:'PC2';isi:2),(ssn:'PC1';isi:1),(ssn:'PC0';isi:0),
    (ssn:'DDC5';isi:5),(ssn:'DDC4';isi:4),(ssn:'DDC3';isi:3),(ssn:'DDC2';isi:2),(ssn:'DDC1';isi:1),(ssn:'DDC0';isi:0),
    (ssn:'PINC5';isi:5),(ssn:'PINC4';isi:4),(ssn:'PINC3';isi:3),(ssn:'PINC2';isi:2),(ssn:'PINC1';isi:1),
    (ssn:'PINC0';isi:0),(ssn:'PD7';isi:7),(ssn:'DDD7';isi:7),(ssn:'PIND7';isi:7),(ssn:'SPH';isi:62),(ssn:'OCR1BH';isi:41),
    (ssn:'OCR1BL';isi:40),(ssn:'PORTA';isi:27),(ssn:'DDRA';isi:26),(ssn:'PINA';isi:25),(ssn:'OCIE1B';isi:5),
    (ssn:'OCF1B';isi:5),(ssn:'SRE';isi:7),(ssn:'SRW';isi:6),(ssn:'COM1B1';isi:5),(ssn:'COM1B0';isi:4),
    (ssn:'WDDE';isi:4),(ssn:'PA7';isi:7),(ssn:'PA6';isi:6),(ssn:'PA5';isi:5),(ssn:'PA4';isi:4),(ssn:'PA3';isi:3),
    (ssn:'PA2';isi:2),(ssn:'PA1';isi:1),(ssn:'PA0';isi:0),(ssn:'DDA7';isi:7),(ssn:'DDA6';isi:6),(ssn:'DDA5';isi:5),
    (ssn:'DDA4';isi:4),(ssn:'DDA3';isi:3),(ssn:'DDA2';isi:2),(ssn:'DDA1';isi:1),(ssn:'DDA0';isi:0),(ssn:'PINA7';isi:7),
    (ssn:'PINA6';isi:6),(ssn:'PINA5';isi:5),(ssn:'PINA4';isi:4),(ssn:'PINA3';isi:3),(ssn:'PINA2';isi:2),
    (ssn:'PINA1';isi:1),(ssn:'PINA0';isi:0),(ssn:'PC7';isi:7),(ssn:'PC6';isi:6),(ssn:'DDC7';isi:7),(ssn:'DDC6';isi:6),
    (ssn:'PINC7';isi:7),(ssn:'PINC6';isi:6),(ssn:'TCCR2';isi:37),(ssn:'TCNT2';isi:36),(ssn:'OCR2';isi:35),
    (ssn:'ASSR';isi:34),(ssn:'EEARH';isi:31),(ssn:'OCIE2';isi:7),(ssn:'TOIE2';isi:6),(ssn:'TICIE1';isi:5),
    (ssn:'OCIE1A';isi:4),(ssn:'OCIE1B';isi:3),(ssn:'TOIE1';isi:2),(ssn:'TOIE0';isi:0),(ssn:'OCF2';isi:7),
    (ssn:'TOV2';isi:6),(ssn:'ICF1';isi:5),(ssn:'OCF1A';isi:4),(ssn:'OCF1B';isi:3),(ssn:'TOV1';isi:2),
    (ssn:'TOV0';isi:0),(ssn:'SE';isi:6),(ssn:'SM1';isi:5),(ssn:'SM0';isi:4),(ssn:'PWM2';isi:6),(ssn:'COM21';isi:5),
    (ssn:'COM20';isi:4),(ssn:'CTC2';isi:3),(ssn:'CS22';isi:2),(ssn:'CS21';isi:1),(ssn:'CS20';isi:0),(ssn:'AS2';isi:3),
    (ssn:'TCN2UB';isi:2),(ssn:'OCR2UB';isi:1),(ssn:'TCR2UB';isi:0),(ssn:'TCCR1';isi:46),(ssn:'GIPR';isi:16),
    (ssn:'IPIN1';isi:3),(ssn:'IPIN0';isi:2),(ssn:'SM';isi:5),(ssn:'ISC1';isi:2),(ssn:'ISC0';isi:0),(ssn:'PCIE';isi:5),
    (ssn:'PCIF';isi:5),(ssn:'OSCCAL';isi:49),(ssn:'PUD';isi:6),(ssn:'CAL7';isi:7),(ssn:'CAL6';isi:6),
    (ssn:'CAL5';isi:5),(ssn:'CAL4';isi:4),(ssn:'CAL3';isi:3),(ssn:'CAL2';isi:2),(ssn:'CAL1';isi:1),(ssn:'CAL0';isi:0),
    (ssn:'TIMSK0';isi:57),(ssn:'TIFR0';isi:56),(ssn:'SPMCSR';isi:55),(ssn:'OCR0A';isi:54),(ssn:'TCCR0B';isi:51),
    (ssn:'TCCR0A';isi:47),(ssn:'DWDR';isi:46),(ssn:'OCR0B';isi:41),(ssn:'GTCCR';isi:40),(ssn:'CLKPR';isi:38),
    (ssn:'PCMSK';isi:21),(ssn:'DIDR0';isi:20),(ssn:'ADCSRA';isi:6),(ssn:'ADCSRB';isi:3),(ssn:'OCIE0B';isi:3),
    (ssn:'OCIE0A';isi:2),(ssn:'OCF0B';isi:3),(ssn:'OCF0A';isi:2),(ssn:'CTPB';isi:4),(ssn:'RFLB';isi:3),
    (ssn:'PGWRT';isi:2),(ssn:'PGERS';isi:1),(ssn:'SPMEN';isi:0),(ssn:'SM1';isi:4),(ssn:'SM0';isi:3),(ssn:'FOC0A';isi:7),
    (ssn:'FOC0B';isi:6),(ssn:'WGM02';isi:3),(ssn:'COM0A1';isi:7),(ssn:'COM0A0';isi:6),(ssn:'COM0B1';isi:5),
    (ssn:'COM0B0';isi:4),(ssn:'WGM01';isi:1),(ssn:'WGM00';isi:0),(ssn:'TSM';isi:7),(ssn:'PSR10';isi:0),
    (ssn:'CLKPCE';isi:7),(ssn:'CLKPS3';isi:3),(ssn:'CLKPS2';isi:2),(ssn:'CLKPS1';isi:1),(ssn:'CLKPS0';isi:0),
    (ssn:'WDTIF';isi:7),(ssn:'WDTIE';isi:6),(ssn:'WDP3';isi:5),(ssn:'WDCE';isi:4),(ssn:'EEPM1';isi:5),
    (ssn:'EEPM0';isi:4),(ssn:'PORTB5';isi:5),(ssn:'PORTB4';isi:4),(ssn:'PORTB3';isi:3),(ssn:'PORTB2';isi:2),
    (ssn:'PORTB1';isi:1),(ssn:'PORTB0';isi:0),(ssn:'PCINT5';isi:5),(ssn:'PCINT4';isi:4),(ssn:'PCINT3';isi:3),
    (ssn:'PCINT2';isi:2),(ssn:'PCINT1';isi:1),(ssn:'PCINT0';isi:0),(ssn:'ADC0D';isi:5),(ssn:'ADC2D';isi:4),
    (ssn:'ADC3D';isi:3),(ssn:'ADC1D';isi:2),(ssn:'EIN1D';isi:1),(ssn:'AIN0D';isi:0),(ssn:'ACBG';isi:6),
    (ssn:'REFS0';isi:6),(ssn:'ADLAR';isi:5),(ssn:'ADATE';isi:5),(ssn:'ACME';isi:6),(ssn:'ADTS2';isi:2),
    (ssn:'ADTS1';isi:1),(ssn:'ADTS0';isi:0),(ssn:'TCCR1';isi:48),(ssn:'TCNT1';isi:47),(ssn:'OCR1A';isi:46),
    (ssn:'OCR1B';isi:45),(ssn:'SFIOR';isi:44),(ssn:'CTC1';isi:7),(ssn:'PWM1';isi:6),(ssn:'COM1A1';isi:5),
    (ssn:'COM1A0';isi:4),(ssn:'CS13';isi:3),(ssn:'AINBG6';isi:6),(ssn:'REFS1';isi:7),(ssn:'FOC1A';isi:2),
    (ssn:'PSR1';isi:1),(ssn:'PSR0';isi:0),(ssn:'OCR1C';isi:45),(ssn:'GTCCR';isi:44),(ssn:'OCR1B';isi:43),
    (ssn:'TCCR0A';isi:42),(ssn:'OCR0A';isi:41),(ssn:'OCR0B';isi:40),(ssn:'PLLCSR';isi:39),(ssn:'DT1A';isi:37),
    (ssn:'DT1B';isi:36),(ssn:'DTPS1';isi:35),(ssn:'DWDR';isi:34),(ssn:'PRR';isi:32),(ssn:'GPIOR2';isi:19),
    (ssn:'GPIOR1';isi:18),(ssn:'GPIOR0';isi:17),(ssn:'USIBR';isi:16),(ssn:'USIDR';isi:15),(ssn:'USISR';isi:14),
    (ssn:'USICR';isi:13),(ssn:'OCIE0A';isi:4),(ssn:'OCF0A';isi:4),(ssn:'PWM1A';isi:6),(ssn:'PWM1B';isi:6),
    (ssn:'FOC1B';isi:3),(ssn:'SM';isi:7),(ssn:'PCKE';isi:2),(ssn:'PLLE';isi:1),(ssn:'PLOCK';isi:0),(ssn:'DT1AH3';isi:7),
    (ssn:'DT1AH2';isi:6),(ssn:'DT1AH1';isi:5),(ssn:'DT1AH0';isi:4),(ssn:'DT1AL3';isi:3),(ssn:'DT1AL2';isi:2),
    (ssn:'DT1AL1';isi:1),(ssn:'DT1AL0';isi:0),(ssn:'DT1BH3';isi:7),(ssn:'DT1BH2';isi:6),(ssn:'DT1BH1';isi:5),
    (ssn:'DT1BH0';isi:4),(ssn:'DT1BL3';isi:3),(ssn:'DT1BL2';isi:2),(ssn:'DT1BL1';isi:1),(ssn:'DT1BL0';isi:0),
    (ssn:'DTPS11';isi:1),(ssn:'DTPS10';isi:0),(ssn:'PRTIM1';isi:3),(ssn:'PRTIM0';isi:2),(ssn:'PRUSI';isi:1),
    (ssn:'PRADC';isi:0),(ssn:'USICIF';isi:7),(ssn:'USIOIF';isi:6),(ssn:'USIPF';isi:5),(ssn:'USIDC';isi:4),
    (ssn:'USICNT3';isi:3),(ssn:'USICNT2';isi:2),(ssn:'USICNT1';isi:1),(ssn:'USICNT0';isi:0),(ssn:'USISIE';isi:7),
    (ssn:'USIOIE';isi:6),(ssn:'USIWM1';isi:5),(ssn:'USIWM0';isi:4),(ssn:'USICS1';isi:3),(ssn:'USICS0';isi:2),
    (ssn:'USICLK';isi:1),(ssn:'USITC';isi:0),(ssn:'REFS2';isi:4),(ssn:'MUX3';isi:3),(ssn:'BIN';isi:7),
    (ssn:'IPR';isi:5),(ssn:'TCCR1A';isi:48),(ssn:'TCCR1B';isi:47),(ssn:'TCNT1';isi:46),(ssn:'OCR1A';isi:45),
    (ssn:'OCR1B';isi:44),(ssn:'OCR1C';isi:43),(ssn:'PLLCSR';isi:41),(ssn:'PCIE1';isi:5),(ssn:'PCIE0';isi:4),
    (ssn:'PSR0';isi:3),(ssn:'OSCCAL4';isi:4),(ssn:'OSCCAL3';isi:3),(ssn:'OSCCAL2';isi:2),(ssn:'OSCCAL1';isi:1),
    (ssn:'OSCCAL0';isi:0),(ssn:'FOC1A';isi:3),(ssn:'FOC1B';isi:2),(ssn:'PWM1A';isi:1),(ssn:'PWM1B';isi:0),
    (ssn:'PSR1';isi:6),(ssn:'EEAR6';isi:6),(ssn:'EEAR5';isi:5),(ssn:'EEAR4';isi:4),(ssn:'EEAR3';isi:3),
    (ssn:'EEAR2';isi:2),(ssn:'EEAR1';isi:1),(ssn:'EEAR0';isi:0),(ssn:'PORTA7';isi:7),(ssn:'PORTA6';isi:6),
    (ssn:'PORTA5';isi:5),(ssn:'PORTA4';isi:4),(ssn:'PORTA3';isi:3),(ssn:'PORTA2';isi:2),(ssn:'PORTA1';isi:1),
    (ssn:'PORTA0';isi:0),(ssn:'PORTB7';isi:7),(ssn:'PORTB6';isi:6),(ssn:'USISIF';isi:7),(ssn:'ACME';isi:2),
    (ssn:'MUX4';isi:4),(ssn:'PACR';isi:26),(ssn:'MCUCS';isi:7),(ssn:'ICR';isi:6),(ssn:'IFR';isi:5),(ssn:'TCCR0';isi:4),
    (ssn:'TCNT0';isi:3),(ssn:'MODCR';isi:2),(ssn:'WDTCR';isi:1),(ssn:'OSCCAL';isi:0),(ssn:'PA2HC';isi:2),
    (ssn:'PLUPB';isi:7),(ssn:'LLIE';isi:5),(ssn:'TOIE0';isi:4),(ssn:'TOV0';isi:4),(ssn:'FOV0';isi:7),
    (ssn:'OOM01';isi:4),(ssn:'OOM00';isi:3),(ssn:'ONTIM4';isi:7),(ssn:'ONTIM3';isi:6),(ssn:'ONTIM2';isi:5),
    (ssn:'ONTIM1';isi:4),(ssn:'ONTIM0';isi:3),(ssn:'MCONF2';isi:2),(ssn:'MCONF1';isi:1),(ssn:'MCONF0';isi:0),
    (ssn:'OCR0B';isi:60),(ssn:'EIFR';isi:58),(ssn:'TCCR0A';isi:48),(ssn:'GTCCR';isi:35),(ssn:'TCCR1C';isi:34),
    (ssn:'PCMSK';isi:32),(ssn:'EEDRL';isi:29),(ssn:'GPIOR2';isi:21),(ssn:'GPIOR1';isi:20),(ssn:'GPIOR0';isi:19),
    (ssn:'UCSRC';isi:3),(ssn:'UBRRH';isi:2),(ssn:'DIDR';isi:1),(ssn:'EEMPE';isi:2),(ssn:'EEPE';isi:1),
    (ssn:'PUD';isi:7),(ssn:'SM1';isi:6),(ssn:'WDIF';isi:7),(ssn:'WDIE';isi:6),(ssn:'PORTD6';isi:6),(ssn:'PORTD5';isi:5),
    (ssn:'PORTD4';isi:4),(ssn:'PORTD3';isi:3),(ssn:'PORTD2';isi:2),(ssn:'PORTD1';isi:1),(ssn:'PORTD0';isi:0),
    (ssn:'PCINT7';isi:7),(ssn:'PCINT6';isi:6),(ssn:'ICIE1';isi:3),(ssn:'OCIE0B';isi:2),(ssn:'OCIE0A';isi:0),
    (ssn:'OCF0B';isi:2),(ssn:'OCF0A';isi:0),(ssn:'WGM11';isi:1),(ssn:'WGM10';isi:0),(ssn:'WGM13';isi:4),
    (ssn:'WGM12';isi:3),(ssn:'FOC1A';isi:7),(ssn:'FOC1B';isi:6),(ssn:'DOR';isi:3),(ssn:'UPE';isi:2),(ssn:'U2X';isi:1),
    (ssn:'UCSZ2';isi:2),(ssn:'UMSEL';isi:6),(ssn:'UPM1';isi:5),(ssn:'UPM0';isi:4),(ssn:'USBS';isi:3),
    (ssn:'UCSZ1';isi:2),(ssn:'UCSZ0';isi:1),(ssn:'UCPOL';isi:0),(ssn:'AIN1D';isi:1),(ssn:'XDIV';isi:60),
    (ssn:'RAMPZ';isi:59),(ssn:'EICR';isi:58),(ssn:'EIMSK';isi:57),(ssn:'EIFR';isi:56),(ssn:'TIMSK';isi:55),
    (ssn:'TIFR';isi:54),(ssn:'OCR0';isi:49),(ssn:'ASSR0';isi:48),(ssn:'PORTE';isi:3),(ssn:'DDRE';isi:2),
    (ssn:'PINE';isi:1),(ssn:'PINF';isi:0),(ssn:'RAMPZ0';isi:0),(ssn:'XDIVEN';isi:7),(ssn:'XDIV6';isi:6),
    (ssn:'XDIV5';isi:5),(ssn:'XDIV4';isi:4),(ssn:'XDIV3';isi:3),(ssn:'XDIV2';isi:2),(ssn:'XDIV1';isi:1),
    (ssn:'XDIV0';isi:0),(ssn:'INT7';isi:7),(ssn:'INT6';isi:6),(ssn:'INT5';isi:5),(ssn:'INT4';isi:4),(ssn:'INT3';isi:3),
    (ssn:'INT2';isi:2),(ssn:'INT1';isi:1),(ssn:'INT0';isi:0),(ssn:'INTF7';isi:7),(ssn:'INTF6';isi:6),
    (ssn:'INTF5';isi:5),(ssn:'INTF4';isi:4),(ssn:'ISC71';isi:7),(ssn:'ISC70';isi:6),(ssn:'ISC61';isi:5),
    (ssn:'ISC60';isi:4),(ssn:'ISC51';isi:3),(ssn:'ISC50';isi:2),(ssn:'ISC41';isi:1),(ssn:'ISC40';isi:0),
    (ssn:'OCIE0';isi:1),(ssn:'OCF0';isi:1),(ssn:'PWM0';isi:6),(ssn:'COM01';isi:5),(ssn:'COM00';isi:4),
    (ssn:'CTC0';isi:3),(ssn:'AS0';isi:3),(ssn:'TCN0UB';isi:2),(ssn:'OCR0UB';isi:1),(ssn:'TCR0UB';isi:0),
    (ssn:'PE7';isi:7),(ssn:'PE6';isi:6),(ssn:'PE5';isi:5),(ssn:'PE4';isi:4),(ssn:'PE3';isi:3),(ssn:'PE2';isi:2),
    (ssn:'PE1';isi:1),(ssn:'PE0';isi:0),(ssn:'DDE7';isi:7),(ssn:'DDE6';isi:6),(ssn:'DDE5';isi:5),(ssn:'DDE4';isi:4),
    (ssn:'DDE3';isi:3),(ssn:'DDE2';isi:2),(ssn:'DDE1';isi:1),(ssn:'DDE0';isi:0),(ssn:'PINE7';isi:7),(ssn:'PINE6';isi:6),
    (ssn:'PINE5';isi:5),(ssn:'PINE4';isi:4),(ssn:'PINE3';isi:3),(ssn:'PINE2';isi:2),(ssn:'PINE1';isi:1),
    (ssn:'PINE0';isi:0),(ssn:'PINF7';isi:7),(ssn:'PINF6';isi:6),(ssn:'PINF5';isi:5),(ssn:'PINF4';isi:4),
    (ssn:'PINF3';isi:3),(ssn:'PINF2';isi:2),(ssn:'PINF1';isi:1),(ssn:'PINF0';isi:0),(ssn:'UCSR1C';isi:157),
    (ssn:'UDR1';isi:156),(ssn:'UCSR1A';isi:155),(ssn:'UCSR1B';isi:154),(ssn:'UBRR1L';isi:153),(ssn:'UBRR1H';isi:152),
    (ssn:'UCSR0C';isi:149),(ssn:'UBRR0H';isi:144),(ssn:'TCCR3C';isi:140),(ssn:'TCCR3A';isi:139),(ssn:'TCCR3B';isi:138),
    (ssn:'TCNT3H';isi:137),(ssn:'TCNT3L';isi:136),(ssn:'OCR3AH';isi:135),(ssn:'OCR3AL';isi:134),(ssn:'OCR3BH';isi:133),
    (ssn:'OCR3BL';isi:132),(ssn:'OCR3CH';isi:131),(ssn:'OCR3CL';isi:130),(ssn:'ICR3H';isi:129),(ssn:'ICR3L';isi:128),
    (ssn:'ETIMSK';isi:125),(ssn:'ETIFR';isi:124),(ssn:'TCCR1C';isi:122),(ssn:'OCR1CH';isi:121),(ssn:'OCR1CL';isi:120),
    (ssn:'TWCR';isi:116),(ssn:'TWDR';isi:115),(ssn:'TWAR';isi:114),(ssn:'TWSR';isi:113),(ssn:'TWBR';isi:112),
    (ssn:'OSCCAL';isi:111),(ssn:'XMCRA';isi:109),(ssn:'XMCRB';isi:108),(ssn:'EICRA';isi:106),(ssn:'SPMCSR';isi:104),
    (ssn:'SPMCR';isi:104),(ssn:'PORTG';isi:101),(ssn:'DDRG';isi:100),(ssn:'PING';isi:99),(ssn:'PORTF';isi:98),
    (ssn:'DDRF';isi:97),(ssn:'EICRB';isi:58),(ssn:'GIMSK';isi:57),(ssn:'GICR';isi:57),(ssn:'GIFR';isi:56),
    (ssn:'MCUCSR';isi:52),(ssn:'ASSR';isi:48),(ssn:'OCDR';isi:34),(ssn:'SFIOR';isi:32),(ssn:'UDR0';isi:12),
    (ssn:'UCSR0A';isi:11),(ssn:'UCSR0B';isi:10),(ssn:'UBRR0L';isi:9),(ssn:'SRW10';isi:6),(ssn:'SM2';isi:2),
    (ssn:'IVSEL';isi:1),(ssn:'IVCE';isi:0),(ssn:'JTD';isi:7),(ssn:'JTRF';isi:4),(ssn:'SRL2';isi:6),(ssn:'SRL1';isi:5),
    (ssn:'SRL0';isi:4),(ssn:'SRW01';isi:3),(ssn:'SRW00';isi:2),(ssn:'SRW11';isi:1),(ssn:'XMBK';isi:7),
    (ssn:'XMM2';isi:2),(ssn:'XMM1';isi:1),(ssn:'XMM0';isi:0),(ssn:'SPMIE';isi:7),(ssn:'ASB';isi:6),(ssn:'ASRE';isi:4),
    (ssn:'RWWSB';isi:6),(ssn:'RWWSRE';isi:4),(ssn:'BLBSET';isi:3),(ssn:'IDRD';isi:7),(ssn:'OCDR6';isi:6),
    (ssn:'OCDR5';isi:5),(ssn:'OCDR4';isi:4),(ssn:'OCDR3';isi:3),(ssn:'OCDR2';isi:2),(ssn:'OCDR1';isi:1),
    (ssn:'OCDR0';isi:0),(ssn:'ADHSM';isi:4),(ssn:'ACME';isi:3),(ssn:'PUD';isi:2),(ssn:'PSR0';isi:1),(ssn:'PSR1';isi:0),
    (ssn:'PSR2';isi:0),(ssn:'PSR3';isi:0),(ssn:'PSR321';isi:0),(ssn:'INTF3';isi:3),(ssn:'INTF2';isi:2),
    (ssn:'INTF1';isi:1),(ssn:'INTF0';isi:0),(ssn:'ISC31';isi:7),(ssn:'ISC30';isi:6),(ssn:'ISC21';isi:5),
    (ssn:'ISC20';isi:4),(ssn:'TICIE3';isi:5),(ssn:'OCIE3A';isi:4),(ssn:'OCIE3B';isi:3),(ssn:'TOIE3';isi:2),
    (ssn:'OCIE3C';isi:1),(ssn:'OCIE1C';isi:0),(ssn:'ICF3';isi:5),(ssn:'OCF3A';isi:4),(ssn:'OCF3B';isi:3),
    (ssn:'TOV3';isi:2),(ssn:'OCF3C';isi:1),(ssn:'OCF1C';isi:0),(ssn:'FOC0';isi:7),(ssn:'COM1C1';isi:3),
    (ssn:'COM1C0';isi:2),(ssn:'CTC11';isi:4),(ssn:'CTC10';isi:3),(ssn:'FOC1C';isi:5),(ssn:'FOC2';isi:7),
    (ssn:'COM3A1';isi:7),(ssn:'COM3A0';isi:6),(ssn:'COM3B1';isi:5),(ssn:'COM3B0';isi:4),(ssn:'COM3C1';isi:3),
    (ssn:'COM3C0';isi:2),(ssn:'PWM31';isi:1),(ssn:'PWM30';isi:0),(ssn:'WGM31';isi:1),(ssn:'WGM30';isi:0),
    (ssn:'ICNC3';isi:7),(ssn:'ICES3';isi:6),(ssn:'CTC31';isi:4),(ssn:'CTC30';isi:3),(ssn:'WGM33';isi:4),
    (ssn:'WGM32';isi:3),(ssn:'CS32';isi:2),(ssn:'CS31';isi:1),(ssn:'CS30';isi:0),(ssn:'FOC3A';isi:7),
    (ssn:'FOC3B';isi:6),(ssn:'FOC3C';isi:5),(ssn:'PE';isi:2),(ssn:'RXC0';isi:7),(ssn:'TXC0';isi:6),(ssn:'UDRE0';isi:5),
    (ssn:'FE0';isi:4),(ssn:'DOR0';isi:3),(ssn:'UPE0';isi:2),(ssn:'U2X0';isi:1),(ssn:'MPCM0';isi:0),(ssn:'RXC1';isi:7),
    (ssn:'TXC1';isi:6),(ssn:'UDRE1';isi:5),(ssn:'FE1';isi:4),(ssn:'DOR1';isi:3),(ssn:'UPE1';isi:2),(ssn:'U2X1';isi:1),
    (ssn:'MPCM1';isi:0),(ssn:'RXCIE0';isi:7),(ssn:'TXCIE0';isi:6),(ssn:'UDRIE0';isi:5),(ssn:'RXEN0';isi:4),
    (ssn:'TXEN0';isi:3),(ssn:'UCSZ02';isi:2),(ssn:'RXB80';isi:1),(ssn:'TXB80';isi:0),(ssn:'RXCIE1';isi:7),
    (ssn:'TXCIE1';isi:6),(ssn:'UDRIE1';isi:5),(ssn:'RXEN1';isi:4),(ssn:'TXEN1';isi:3),(ssn:'UCSZ12';isi:2),
    (ssn:'RXB81';isi:1),(ssn:'TXB81';isi:0),(ssn:'UMSEL0';isi:6),(ssn:'UPM01';isi:5),(ssn:'UPM00';isi:4),
    (ssn:'USBS0';isi:3),(ssn:'UCSZ01';isi:2),(ssn:'UCSZ00';isi:1),(ssn:'UCPOL0';isi:0),(ssn:'UMSEL1';isi:6),
    (ssn:'UPM11';isi:5),(ssn:'UPM10';isi:4),(ssn:'USBS1';isi:3),(ssn:'UCSZ11';isi:2),(ssn:'UCSZ10';isi:1),
    (ssn:'UCPOL1';isi:0),(ssn:'SPI2X';isi:0),(ssn:'TWINT';isi:7),(ssn:'TWEA';isi:6),(ssn:'TWSTA';isi:5),
    (ssn:'TWSTO';isi:4),(ssn:'TWWC';isi:3),(ssn:'TWEN';isi:2),(ssn:'TWIE';isi:0),(ssn:'TWS7';isi:7),(ssn:'TWS6';isi:6),
    (ssn:'TWS5';isi:5),(ssn:'TWS4';isi:4),(ssn:'TWS3';isi:3),(ssn:'TWGCE';isi:0),(ssn:'PORTC7';isi:7),
    (ssn:'PORTC6';isi:6),(ssn:'PORTC5';isi:5),(ssn:'PORTC4';isi:4),(ssn:'PORTC3';isi:3),(ssn:'PORTC2';isi:2),
    (ssn:'PORTC1';isi:1),(ssn:'PORTC0';isi:0),(ssn:'PORTD7';isi:7),(ssn:'PORTE7';isi:7),(ssn:'PORTE6';isi:6),
    (ssn:'PORTE5';isi:5),(ssn:'PORTE4';isi:4),(ssn:'PORTE3';isi:3),(ssn:'PORTE2';isi:2),(ssn:'PORTE1';isi:1),
    (ssn:'PORTE0';isi:0),(ssn:'PF7';isi:7),(ssn:'PF6';isi:6),(ssn:'PF5';isi:5),(ssn:'PF4';isi:4),(ssn:'PF3';isi:3),
    (ssn:'PF2';isi:2),(ssn:'PF1';isi:1),(ssn:'PF0';isi:0),(ssn:'PORTF7';isi:7),(ssn:'PORTF6';isi:6),(ssn:'PORTF5';isi:5),
    (ssn:'PORTF4';isi:4),(ssn:'PORTF3';isi:3),(ssn:'PORTF2';isi:2),(ssn:'PORTF1';isi:1),(ssn:'PORTF0';isi:0),
    (ssn:'DDF7';isi:7),(ssn:'DDF6';isi:6),(ssn:'DDF5';isi:5),(ssn:'DDF4';isi:4),(ssn:'DDF3';isi:3),(ssn:'DDF2';isi:2),
    (ssn:'DDF1';isi:1),(ssn:'DDF0';isi:0),(ssn:'PG4';isi:4),(ssn:'PG3';isi:3),(ssn:'PG2';isi:2),(ssn:'PG1';isi:1),
    (ssn:'PG0';isi:0),(ssn:'DDG4';isi:4),(ssn:'DDG3';isi:3),(ssn:'DDG2';isi:2),(ssn:'DDG1';isi:1),(ssn:'DDG0';isi:0),
    (ssn:'PING4';isi:4),(ssn:'PING3';isi:3),(ssn:'PING2';isi:2),(ssn:'PING1';isi:1),(ssn:'PING0';isi:0),
    (ssn:'SMALLBOOTSTART';isi:65024),(ssn:'SECONDBOOTSTART';isi:64512),(ssn:'THIRDBOOTSTART';isi:63488),
    (ssn:'LARGEBOOTSTART';isi:61440),(ssn:'PAGESIZE';isi:128),(ssn:'UDR3';isi:310),(ssn:'UBRR3H';isi:309),
    (ssn:'UBRR3L';isi:308),(ssn:'UCSR3C';isi:306),(ssn:'UCSR3B';isi:305),(ssn:'UCSR3A';isi:304),(ssn:'OCR5CH';isi:301),
    (ssn:'OCR5CL';isi:300),(ssn:'OCR5BH';isi:299),(ssn:'OCR5BL';isi:298),(ssn:'OCR5AH';isi:297),(ssn:'OCR5AL';isi:296),
    (ssn:'ICR5H';isi:295),(ssn:'ICR5L';isi:294),(ssn:'TCNT5H';isi:293),(ssn:'TCNT5L';isi:292),(ssn:'TCCR5C';isi:290),
    (ssn:'TCCR5B';isi:289),(ssn:'TCCR5A';isi:288),(ssn:'PORTL';isi:267),(ssn:'DDRL';isi:266),(ssn:'PINL';isi:265),
    (ssn:'PORTK';isi:264),(ssn:'DDRK';isi:263),(ssn:'PINK';isi:262),(ssn:'PORTJ';isi:261),(ssn:'DDRJ';isi:260),
    (ssn:'PINJ';isi:259),(ssn:'PORTH';isi:258),(ssn:'DDRH';isi:257),(ssn:'PINH';isi:256),(ssn:'UDR2';isi:214),
    (ssn:'UBRR2H';isi:213),(ssn:'UBRR2L';isi:212),(ssn:'UCSR2C';isi:210),(ssn:'UCSR2B';isi:209),(ssn:'UCSR2A';isi:208),
    (ssn:'UDR1';isi:206),(ssn:'UBRR1H';isi:205),(ssn:'UBRR1L';isi:204),(ssn:'UCSR1C';isi:202),(ssn:'UCSR1B';isi:201),
    (ssn:'UCSR1A';isi:200),(ssn:'UDR0';isi:198),(ssn:'UBRR0H';isi:197),(ssn:'UBRR0L';isi:196),(ssn:'UCSR0C';isi:194),
    (ssn:'UCSR0B';isi:193),(ssn:'UCSR0A';isi:192),(ssn:'TWAMR';isi:189),(ssn:'TWCR';isi:188),(ssn:'TWDR';isi:187),
    (ssn:'TWAR';isi:186),(ssn:'TWSR';isi:185),(ssn:'TWBR';isi:184),(ssn:'ASSR';isi:182),(ssn:'OCR2B';isi:180),
    (ssn:'OCR2A';isi:179),(ssn:'TCNT2';isi:178),(ssn:'TCCR2B';isi:177),(ssn:'TCCR2A';isi:176),(ssn:'OCR4CH';isi:173),
    (ssn:'OCR4CL';isi:172),(ssn:'OCR4BH';isi:171),(ssn:'OCR4BL';isi:170),(ssn:'OCR4AH';isi:169),(ssn:'OCR4AL';isi:168),
    (ssn:'ICR4H';isi:167),(ssn:'ICR4L';isi:166),(ssn:'TCNT4H';isi:165),(ssn:'TCNT4L';isi:164),(ssn:'TCCR4C';isi:162),
    (ssn:'TCCR4B';isi:161),(ssn:'TCCR4A';isi:160),(ssn:'OCR3CH';isi:157),(ssn:'OCR3CL';isi:156),(ssn:'OCR3BH';isi:155),
    (ssn:'OCR3BL';isi:154),(ssn:'OCR3AH';isi:153),(ssn:'OCR3AL';isi:152),(ssn:'ICR3H';isi:151),(ssn:'ICR3L';isi:150),
    (ssn:'TCNT3H';isi:149),(ssn:'TCNT3L';isi:148),(ssn:'TCCR3C';isi:146),(ssn:'TCCR3B';isi:145),(ssn:'TCCR3A';isi:144),
    (ssn:'OCR1CH';isi:141),(ssn:'OCR1CL';isi:140),(ssn:'OCR1BH';isi:139),(ssn:'OCRB1L';isi:138),(ssn:'OCR1AH';isi:137),
    (ssn:'OCR1AL';isi:136),(ssn:'ICR1H';isi:135),(ssn:'ICR1L';isi:134),(ssn:'TCNT1H';isi:133),(ssn:'TCNT1L';isi:132),
    (ssn:'TCCR1C';isi:130),(ssn:'TCCR1B';isi:129),(ssn:'TCCR1A';isi:128),(ssn:'DIDR1';isi:127),(ssn:'DIDR0';isi:126),
    (ssn:'DIDR2';isi:125),(ssn:'ADMUX';isi:124),(ssn:'ADCSRB';isi:123),(ssn:'ADCSRA';isi:122),(ssn:'ADCH';isi:121),
    (ssn:'ADCL';isi:120),(ssn:'XMCRB';isi:117),(ssn:'XMCRA';isi:116),(ssn:'TIMSK5';isi:115),(ssn:'TIMSK4';isi:114),
    (ssn:'TIMSK3';isi:113),(ssn:'TIMSK2';isi:112),(ssn:'TIMSK1';isi:111),(ssn:'TIMSK0';isi:110),(ssn:'PCMSK2';isi:109),
    (ssn:'PCMSK1';isi:108),(ssn:'PCMSK0';isi:107),(ssn:'EICRB';isi:106),(ssn:'EICRA';isi:105),(ssn:'PCICR';isi:104),
    (ssn:'OSCCAL';isi:102),(ssn:'PRR1';isi:101),(ssn:'PRR0';isi:100),(ssn:'CLKPR';isi:97),(ssn:'WDTCSR';isi:96),
    (ssn:'EIND';isi:60),(ssn:'SMCR';isi:51),(ssn:'OCDR';isi:49),(ssn:'MONDR';isi:49),(ssn:'ACSR';isi:48),
    (ssn:'SPDR';isi:46),(ssn:'SPSR';isi:45),(ssn:'SPCR';isi:44),(ssn:'GPIOR2';isi:43),(ssn:'GPIOR1';isi:42),
    (ssn:'OCR0A';isi:39),(ssn:'TCNT0';isi:38),(ssn:'TCCR0B';isi:37),(ssn:'TCCR0A';isi:36),(ssn:'EEARH';isi:34),
    (ssn:'EEARL';isi:33),(ssn:'EEDR';isi:32),(ssn:'EECR';isi:31),(ssn:'GPIOR0';isi:30),(ssn:'EIMSK';isi:29),
    (ssn:'EIFR';isi:28),(ssn:'PCIFR';isi:27),(ssn:'TIFR5';isi:26),(ssn:'TIFR4';isi:25),(ssn:'TIFR3';isi:24),
    (ssn:'TIFR2';isi:23),(ssn:'TIFR1';isi:22),(ssn:'TIFR0';isi:21),(ssn:'PORTG';isi:20),(ssn:'DDRG';isi:19),
    (ssn:'PING';isi:18),(ssn:'PORTF';isi:17),(ssn:'DDRF';isi:16),(ssn:'PINF';isi:15),(ssn:'PORTE';isi:14),
    (ssn:'DDRE';isi:13),(ssn:'PINE';isi:12),(ssn:'PORTD';isi:11),(ssn:'DDRD';isi:10),(ssn:'PIND';isi:9),
    (ssn:'PORTC';isi:8),(ssn:'DDRC';isi:7),(ssn:'PINC';isi:6),(ssn:'PORTB';isi:5),(ssn:'DDRB';isi:4),
    (ssn:'PINB';isi:3),(ssn:'PORTA';isi:2),(ssn:'DDRA';isi:1),(ssn:'PINA';isi:0),(ssn:'UMSEL31';isi:7),
    (ssn:'UMSEL30';isi:6),(ssn:'UPM31';isi:5),(ssn:'UPM30';isi:4),(ssn:'USBS3';isi:3),(ssn:'UCSZ31';isi:2),
    (ssn:'UCSZ30';isi:1),(ssn:'UCPOL3';isi:0),(ssn:'RXCIE3';isi:7),(ssn:'TXCIE3';isi:6),(ssn:'UDRIE3';isi:5),
    (ssn:'RXEN3';isi:4),(ssn:'TXEN3';isi:3),(ssn:'UCSZ32';isi:2),(ssn:'RXB83';isi:1),(ssn:'TXB83';isi:0),
    (ssn:'RXC3';isi:7),(ssn:'TXC3';isi:6),(ssn:'UDRE3';isi:5),(ssn:'FE3';isi:4),(ssn:'DOR3';isi:3),(ssn:'UPE3';isi:2),
    (ssn:'U2X3';isi:1),(ssn:'MPCM3';isi:0),(ssn:'FOC5A';isi:7),(ssn:'FOC5B';isi:6),(ssn:'FOC5C';isi:5),
    (ssn:'ICNC5';isi:7),(ssn:'ICES5';isi:6),(ssn:'WGM53';isi:4),(ssn:'WGM52';isi:3),(ssn:'CS52';isi:2),
    (ssn:'CS51';isi:1),(ssn:'CS50';isi:0),(ssn:'COM5A1';isi:7),(ssn:'COM5A0';isi:6),(ssn:'COM5B1';isi:5),
    (ssn:'COM5B0';isi:4),(ssn:'COM5C1';isi:3),(ssn:'COM5C0';isi:2),(ssn:'WGM51';isi:1),(ssn:'WGM50';isi:0),
    (ssn:'PORTL7';isi:7),(ssn:'PORTL6';isi:6),(ssn:'PORTL5';isi:5),(ssn:'PORTL4';isi:4),(ssn:'PORTL3';isi:3),
    (ssn:'PORTL2';isi:2),(ssn:'PORTL1';isi:1),(ssn:'PORTL0';isi:0),(ssn:'DDRL7';isi:7),(ssn:'DDRL6';isi:6),
    (ssn:'DDRL5';isi:5),(ssn:'DDRL4';isi:4),(ssn:'DDRL3';isi:3),(ssn:'DDRL2';isi:2),(ssn:'DDRL1';isi:1),
    (ssn:'DDRL0';isi:0),(ssn:'PINL7';isi:7),(ssn:'PINL6';isi:6),(ssn:'PINL5';isi:5),(ssn:'PINL4';isi:4),
    (ssn:'PINL3';isi:3),(ssn:'PINL2';isi:2),(ssn:'PINL1';isi:1),(ssn:'PINL0';isi:0),(ssn:'PORTK7';isi:7),
    (ssn:'PORTK6';isi:6),(ssn:'PORTK5';isi:5),(ssn:'PORTK4';isi:4),(ssn:'PORTK3';isi:3),(ssn:'PORTK2';isi:2),
    (ssn:'PORTK1';isi:1),(ssn:'PORTK0';isi:0),(ssn:'DDRK7';isi:7),(ssn:'DDRK6';isi:6),(ssn:'DDRK5';isi:5),
    (ssn:'DDRK4';isi:4),(ssn:'DDRK3';isi:3),(ssn:'DDRK2';isi:2),(ssn:'DDRK1';isi:1),(ssn:'DDRK0';isi:0),
    (ssn:'PINK7';isi:7),(ssn:'PINK6';isi:6),(ssn:'PINK5';isi:5),(ssn:'PINK4';isi:4),(ssn:'PINK3';isi:3),
    (ssn:'PINK2';isi:2),(ssn:'PINK1';isi:1),(ssn:'PINK0';isi:0),(ssn:'PORTJ7';isi:7),(ssn:'PORTJ6';isi:6),
    (ssn:'PORTJ5';isi:5),(ssn:'PORTJ4';isi:4),(ssn:'PORTJ3';isi:3),(ssn:'PORTJ2';isi:2),(ssn:'PORTJ1';isi:1),
    (ssn:'PORTJ0';isi:0),(ssn:'DDRJ7';isi:7),(ssn:'DDRJ6';isi:6),(ssn:'DDRJ5';isi:5),(ssn:'DDRJ4';isi:4),
    (ssn:'DDRJ3';isi:3),(ssn:'DDRJ2';isi:2),(ssn:'DDRJ1';isi:1),(ssn:'DDRJ0';isi:0),(ssn:'PINJ7';isi:7),
    (ssn:'PINJ6';isi:6),(ssn:'PINJ5';isi:5),(ssn:'PINJ4';isi:4),(ssn:'PINJ3';isi:3),(ssn:'PINJ2';isi:2),
    (ssn:'PINJ1';isi:1),(ssn:'PINJ0';isi:0),(ssn:'PORTH7';isi:7),(ssn:'PORTH6';isi:6),(ssn:'PORTH5';isi:5),
    (ssn:'PORTH4';isi:4),(ssn:'PORTH3';isi:3),(ssn:'PORTH2';isi:2),(ssn:'PORTH1';isi:1),(ssn:'PORTH0';isi:0),
    (ssn:'DDRH7';isi:7),(ssn:'DDRH6';isi:6),(ssn:'DDRH5';isi:5),(ssn:'DDRH4';isi:4),(ssn:'DDRH3';isi:3),
    (ssn:'DDRH2';isi:2),(ssn:'DDRH1';isi:1),(ssn:'DDRH0';isi:0),(ssn:'PINH7';isi:7),(ssn:'PINH6';isi:6),
    (ssn:'PINH5';isi:5),(ssn:'PINH4';isi:4),(ssn:'PINH3';isi:3),(ssn:'PINH2';isi:2),(ssn:'PINH1';isi:1),
    (ssn:'PINH0';isi:0),(ssn:'UMSEL21';isi:7),(ssn:'UMSEL20';isi:6),(ssn:'UPM21';isi:5),(ssn:'UPM20';isi:4),
    (ssn:'USBS2';isi:3),(ssn:'UCSZ21';isi:2),(ssn:'UCSZ20';isi:3),(ssn:'UPOL2';isi:2),(ssn:'RXCIE2';isi:7),
    (ssn:'TXCIE2';isi:6),(ssn:'UDRIE2';isi:5),(ssn:'RXEN2';isi:4),(ssn:'TXEN2';isi:3),(ssn:'UCSZ22';isi:2),
    (ssn:'RXB82';isi:1),(ssn:'TXB82';isi:0),(ssn:'RXC2';isi:7),(ssn:'TXC2';isi:6),(ssn:'UDRE2';isi:5),
    (ssn:'FE2';isi:4),(ssn:'DOR2';isi:3),(ssn:'UPE2';isi:2),(ssn:'U2X2';isi:1),(ssn:'MPCM2';isi:0),(ssn:'UMSEL11';isi:7),
    (ssn:'UMSEL10';isi:6),(ssn:'UCSZ10';isi:3),(ssn:'UPOL1';isi:2),(ssn:'UMSEL01';isi:7),(ssn:'UMSEL00';isi:6),
    (ssn:'UCSZ00';isi:3),(ssn:'UPOL0';isi:2),(ssn:'TWAM6';isi:7),(ssn:'TWAM5';isi:6),(ssn:'TWAM4';isi:5),
    (ssn:'TWAM3';isi:4),(ssn:'TWAM2';isi:3),(ssn:'TWAM1';isi:2),(ssn:'TWAM0';isi:1),(ssn:'TWA6';isi:7),
    (ssn:'TWA5';isi:6),(ssn:'TWA4';isi:5),(ssn:'TWA3';isi:4),(ssn:'TWA2';isi:3),(ssn:'TWA1';isi:2),(ssn:'TWA0';isi:1),
    (ssn:'TWPS1';isi:1),(ssn:'TWPS0';isi:0),(ssn:'EXCLK';isi:6),(ssn:'AS2';isi:5),(ssn:'TCN2UB';isi:4),
    (ssn:'OCR2AUB';isi:3),(ssn:'OCR2BUB';isi:2),(ssn:'TCR2AUB';isi:1),(ssn:'TCR2BUB';isi:0),(ssn:'FOC2A';isi:7),
    (ssn:'FOC2B';isi:6),(ssn:'WGM22';isi:3),(ssn:'COM2A1';isi:7),(ssn:'COM2A0';isi:6),(ssn:'COM2B1';isi:5),
    (ssn:'COM2B0';isi:4),(ssn:'WGM21';isi:1),(ssn:'WGM20';isi:0),(ssn:'FOC4A';isi:7),(ssn:'FOC4B';isi:6),
    (ssn:'FOC4C';isi:5),(ssn:'ICNC4';isi:7),(ssn:'ICES4';isi:6),(ssn:'WGM43';isi:4),(ssn:'WGM42';isi:3),
    (ssn:'CS42';isi:2),(ssn:'CS41';isi:1),(ssn:'CS40';isi:0),(ssn:'COM4A1';isi:7),(ssn:'COM4A0';isi:6),
    (ssn:'COM4B1';isi:5),(ssn:'COM4B0';isi:4),(ssn:'COM4C1';isi:3),(ssn:'COM4C0';isi:2),(ssn:'WGM41';isi:1),
    (ssn:'WGM40';isi:0),(ssn:'ADC7D';isi:7),(ssn:'ADC6D';isi:6),(ssn:'ADC5D';isi:5),(ssn:'ADC4D';isi:4),
    (ssn:'ADC2D';isi:2),(ssn:'ADC1D';isi:1),(ssn:'ADC0D';isi:0),(ssn:'ADC15D';isi:7),(ssn:'ADC14D';isi:6),
    (ssn:'ADC13D';isi:5),(ssn:'ADC12D';isi:4),(ssn:'ADC11D';isi:3),(ssn:'ADC10D';isi:2),(ssn:'ADC9D';isi:1),
    (ssn:'ADC8D';isi:0),(ssn:'MUX5';isi:3),(ssn:'SRW11';isi:3),(ssn:'SRW10';isi:2),(ssn:'SRW01';isi:1),
    (ssn:'SRW00';isi:0),(ssn:'ICIE5';isi:5),(ssn:'OCIE5C';isi:3),(ssn:'OCIE5B';isi:2),(ssn:'OCIE5A';isi:1),
    (ssn:'TOIE5';isi:0),(ssn:'ICIE4';isi:5),(ssn:'OCIE4C';isi:3),(ssn:'OCIE4B';isi:2),(ssn:'OCIE4A';isi:1),
    (ssn:'TOIE4';isi:0),(ssn:'ICIE3';isi:5),(ssn:'OCIE3C';isi:3),(ssn:'OCIE3B';isi:2),(ssn:'OCIE3A';isi:1),
    (ssn:'TOIE3';isi:0),(ssn:'OCIE2B';isi:2),(ssn:'OCIE2A';isi:1),(ssn:'TOIE2';isi:0),(ssn:'ICIE1';isi:5),
    (ssn:'OCIE1C';isi:3),(ssn:'OCIE1B';isi:2),(ssn:'OCIE1A';isi:1),(ssn:'TOIE1';isi:0),(ssn:'OCIE0A';isi:1),
    (ssn:'PCINT23';isi:7),(ssn:'PCINT22';isi:6),(ssn:'PCINT21';isi:5),(ssn:'PCINT20';isi:4),(ssn:'PCINT19';isi:3),
    (ssn:'PCINT18';isi:2),(ssn:'PCINT17';isi:1),(ssn:'PCINT16';isi:0),(ssn:'PCINT15';isi:7),(ssn:'PCINT14';isi:6),
    (ssn:'PCINT13';isi:5),(ssn:'PCINT12';isi:4),(ssn:'PCINT11';isi:3),(ssn:'PCINT10';isi:2),(ssn:'PCINT9';isi:1),
    (ssn:'PCINT8';isi:0),(ssn:'PCIE2';isi:2),(ssn:'PCIE1';isi:1),(ssn:'PCIE0';isi:0),(ssn:'PRTIM5';isi:5),
    (ssn:'PRTIM4';isi:4),(ssn:'PRTIM3';isi:3),(ssn:'PRUSART3';isi:2),(ssn:'PRUSART2';isi:1),(ssn:'PRUSART1';isi:0),
    (ssn:'PRTWI';isi:7),(ssn:'PRTIM2';isi:6),(ssn:'PRTIM0';isi:5),(ssn:'PRSPI';isi:2),(ssn:'PRUSART0';isi:1),
    (ssn:'SP15';isi:7),(ssn:'SP14';isi:6),(ssn:'SP13';isi:5),(ssn:'SP12';isi:4),(ssn:'SP11';isi:3),(ssn:'SP10';isi:2),
    (ssn:'SP9';isi:1),(ssn:'SP8';isi:0),(ssn:'EIND0';isi:0),(ssn:'RAMPZ1';isi:1),(ssn:'SIGRID';isi:5),
    (ssn:'PUD';isi:4),(ssn:'SM2';isi:3),(ssn:'SM1';isi:2),(ssn:'SM0';isi:1),(ssn:'SE';isi:0),(ssn:'OCDR7';isi:7),
    (ssn:'PSRASY';isi:1),(ssn:'PSRSYNC';isi:0),(ssn:'PCIF2';isi:2),(ssn:'PCIF1';isi:1),(ssn:'PCIF0';isi:0),
    (ssn:'ICF5';isi:5),(ssn:'OCF5C';isi:3),(ssn:'OCF5B';isi:2),(ssn:'OCF5A';isi:1),(ssn:'TOV5';isi:0),
    (ssn:'ICF4';isi:5),(ssn:'OCF4C';isi:3),(ssn:'OCF4B';isi:2),(ssn:'OCF4A';isi:1),(ssn:'TOV4';isi:0),
    (ssn:'OCF3C';isi:3),(ssn:'OCF3B';isi:2),(ssn:'OCF3A';isi:1),(ssn:'TOV3';isi:0),(ssn:'OCF2B';isi:2),
    (ssn:'OCF2A';isi:1),(ssn:'TOV2';isi:0),(ssn:'OCF1C';isi:3),(ssn:'OCF1B';isi:2),(ssn:'OCF1A';isi:1),
    (ssn:'TOV1';isi:0),(ssn:'OCF0A';isi:1),(ssn:'PORTG5';isi:5),(ssn:'PORTG4';isi:4),(ssn:'PORTG3';isi:3),
    (ssn:'PORTG2';isi:2),(ssn:'PORTG1';isi:1),(ssn:'PORTG0';isi:0),(ssn:'DDRG5';isi:5),(ssn:'DDRG4';isi:4),
    (ssn:'DDRG3';isi:3),(ssn:'DDRG2';isi:2),(ssn:'DDRG1';isi:1),(ssn:'DDRG0';isi:0),(ssn:'PING5';isi:5),
    (ssn:'DDRF7';isi:7),(ssn:'DDRF6';isi:6),(ssn:'DDRF5';isi:5),(ssn:'DDRF4';isi:4),(ssn:'DDRF3';isi:3),
    (ssn:'DDRF2';isi:2),(ssn:'DDRF1';isi:1),(ssn:'DDRF0';isi:0),(ssn:'DDRE7';isi:7),(ssn:'DDRE6';isi:6),
    (ssn:'DDRE5';isi:5),(ssn:'DDRE4';isi:4),(ssn:'DDRE3';isi:3),(ssn:'DDRE2';isi:2),(ssn:'DDRE1';isi:1),
    (ssn:'DDRE0';isi:0),(ssn:'DDRD7';isi:7),(ssn:'DDRD6';isi:6),(ssn:'DDRD5';isi:5),(ssn:'DDRD4';isi:4),
    (ssn:'DDRD3';isi:3),(ssn:'DDRD2';isi:2),(ssn:'DDRD1';isi:1),(ssn:'DDRD0';isi:0),(ssn:'DDRC7';isi:7),
    (ssn:'DDRC6';isi:6),(ssn:'DDRC5';isi:5),(ssn:'DDRC4';isi:4),(ssn:'DDRC3';isi:3),(ssn:'DDRC2';isi:2),
    (ssn:'DDRC1';isi:1),(ssn:'DDRC0';isi:0),(ssn:'DDRB7';isi:7),(ssn:'DDRB6';isi:6),(ssn:'DDRB5';isi:5),
    (ssn:'DDRB4';isi:4),(ssn:'DDRB3';isi:3),(ssn:'DDRB2';isi:2),(ssn:'DDRB1';isi:1),(ssn:'DDRB0';isi:0),
    (ssn:'DDRA7';isi:7),(ssn:'DDRA6';isi:6),(ssn:'DDRA5';isi:5),(ssn:'DDRA4';isi:4),(ssn:'DDRA3';isi:3),
    (ssn:'DDRA2';isi:2),(ssn:'DDRA1';isi:1),(ssn:'DDRA0';isi:0),(ssn:'WGM00';isi:6),(ssn:'WGM01';isi:3),
    (ssn:'WGM20';isi:6),(ssn:'WGM21';isi:3),(ssn:'SPMCR';isi:55),(ssn:'EMCUCR';isi:54),(ssn:'SFIOR';isi:48),
    (ssn:'TCCR2';isi:39),(ssn:'ASSR';isi:38),(ssn:'TCNT2';isi:35),(ssn:'OCR2';isi:34),(ssn:'UBRRHI';isi:32),
    (ssn:'UBRR0';isi:9),(ssn:'PORTE';isi:7),(ssn:'DDRE';isi:6),(ssn:'PINE';isi:5),(ssn:'UDR1';isi:3),
    (ssn:'UCSR1A';isi:2),(ssn:'UCSR1B';isi:1),(ssn:'UBRR1';isi:0),(ssn:'INT2';isi:5),(ssn:'INTF2';isi:5),
    (ssn:'TOIE2';isi:4),(ssn:'OCIE2';isi:2),(ssn:'OCIE0';isi:0),(ssn:'TOV2';isi:4),(ssn:'OCF2';isi:2),
    (ssn:'OCF0';isi:0),(ssn:'SM0';isi:7),(ssn:'ISC2';isi:0),(ssn:'PSR2';isi:1),(ssn:'OR0';isi:3),(ssn:'OR1';isi:3),
    (ssn:'CHR90';isi:2),(ssn:'CHR91';isi:2),(ssn:'BLB12';isi:5),(ssn:'BLB11';isi:4),(ssn:'BLB02';isi:3),
    (ssn:'BLB01';isi:2),(ssn:'BOOTSTART';isi:7680),(ssn:'UCSR1C';isi:60),(ssn:'UBRR1H';isi:60),(ssn:'EIMSK';isi:59),
    (ssn:'GICR';isi:59),(ssn:'UCSR0C';isi:32),(ssn:'UBRR0H';isi:32),(ssn:'OSCCAL';isi:4),(ssn:'UBRR1L';isi:0),
    (ssn:'FOC3A';isi:3),(ssn:'FOC3B';isi:2),(ssn:'PCIE1';isi:4),(ssn:'PCIE0';isi:3),(ssn:'PCIF1';isi:4),
    (ssn:'PCIF0';isi:3),(ssn:'OCIE2';isi:4),(ssn:'TOIE2';isi:2),(ssn:'OCF2';isi:4),(ssn:'TOV2';isi:2),
    (ssn:'SM2';isi:5),(ssn:'XMBK';isi:6),(ssn:'XMM2';isi:5),(ssn:'XMM1';isi:4),(ssn:'XMM0';isi:3),(ssn:'PE0';isi:2),
    (ssn:'PE1';isi:2),(ssn:'URSEL0';isi:7),(ssn:'URSEL1';isi:7),(ssn:'SMALLBOOTSTART';isi:8064),(ssn:'SECONDBOOTSTART';isi:7936),
    (ssn:'THIRDBOOTSTART';isi:7680),(ssn:'LARGEBOOTSTART';isi:7168),(ssn:'PAGESIZE';isi:64),(ssn:'TWCR';isi:54),
    (ssn:'TWDR';isi:3),(ssn:'TWAR';isi:2),(ssn:'TWSR';isi:1),(ssn:'TWBR';isi:0),(ssn:'UDR';isi:198),(ssn:'UBRRH';isi:197),
    (ssn:'UBRRL';isi:196),(ssn:'UCSRC';isi:194),(ssn:'UCSRB';isi:193),(ssn:'UCSRA';isi:192),(ssn:'USIDR';isi:186),
    (ssn:'USISR';isi:185),(ssn:'USICR';isi:184),(ssn:'PRR';isi:100),(ssn:'WDTCR';isi:96),(ssn:'COM2A1';isi:5),
    (ssn:'COM2A0';isi:4),(ssn:'OCD';isi:7),(ssn:'COM0A1';isi:5),(ssn:'COM0A0';isi:4),(ssn:'PCIE1';isi:7),
    (ssn:'PCIE0';isi:6),(ssn:'PCIF1';isi:7),(ssn:'PCIF0';isi:6),(ssn:'OCR1BL';isi:138),(ssn:'DIDR1';isi:121),
    (ssn:'DIDR0';isi:120),(ssn:'CPIOR0';isi:30),(ssn:'USBSO';isi:3),(ssn:'UDORD0';isi:2),(ssn:'UCPHA0';isi:1),
    (ssn:'I';isi:7),(ssn:'T';isi:6),(ssn:'H';isi:5),(ssn:'S';isi:4),(ssn:'V';isi:3),(ssn:'N';isi:2),(ssn:'Z';isi:1),
    (ssn:'C';isi:0),(ssn:'PDWRT';isi:2),(ssn:'SELFPRGEN';isi:0),(ssn:'SMALLBOOTSTART';isi:3968),(ssn:'SECONDBOOTSTART';isi:3840),
    (ssn:'THIRDBOOTSTART';isi:3584),(ssn:'LARGEBOOTSTART';isi:3072),(ssn:'BOOTSTART';isi:3584),(ssn:'PAGESIZE';isi:32),
    (ssn:'LCDDR18';isi:254),(ssn:'LCDDR17';isi:253),(ssn:'LCDDR16';isi:252),(ssn:'LCDDR15';isi:251),(ssn:'LCDDR13';isi:249),
    (ssn:'LCDDR12';isi:248),(ssn:'LCDDR11';isi:247),(ssn:'LCDDR10';isi:246),(ssn:'LCDDR8';isi:244),(ssn:'LCDDR7';isi:243),
    (ssn:'LCDDR6';isi:242),(ssn:'LCDDR5';isi:241),(ssn:'LCDDR3';isi:239),(ssn:'LCDDR2';isi:238),(ssn:'LCDDR1';isi:237),
    (ssn:'LCDDR0';isi:236),(ssn:'LCDCCR';isi:231),(ssn:'LCDFRR';isi:230),(ssn:'LCDCRB';isi:229),(ssn:'LCDCRA';isi:228),
    (ssn:'SEG24';isi:0),(ssn:'SEG23';isi:7),(ssn:'SEG22';isi:6),(ssn:'SEG21';isi:5),(ssn:'SEG20';isi:4),
    (ssn:'SEG19';isi:3),(ssn:'SEG18';isi:2),(ssn:'SEG17';isi:1),(ssn:'SEG16';isi:0),(ssn:'SEG15';isi:7),
    (ssn:'SEG14';isi:6),(ssn:'SEG13';isi:5),(ssn:'SEG12';isi:4),(ssn:'SEG11';isi:3),(ssn:'SEG10';isi:2),
    (ssn:'SEG9';isi:1),(ssn:'SEG8';isi:0),(ssn:'SEG7';isi:7),(ssn:'SEG6';isi:6),(ssn:'SEG5';isi:5),(ssn:'SEG4';isi:4),
    (ssn:'SEG3';isi:3),(ssn:'SEG2';isi:2),(ssn:'SEG1';isi:1),(ssn:'SEG0';isi:0),(ssn:'LCDCC3';isi:3),
    (ssn:'LCDCC2';isi:2),(ssn:'LCDCC1';isi:1),(ssn:'LCDCC0';isi:0),(ssn:'LCDPS2';isi:6),(ssn:'LCDPS1';isi:5),
    (ssn:'LCDPS0';isi:4),(ssn:'LCDCD2';isi:2),(ssn:'LCDCD1';isi:1),(ssn:'LCDCD0';isi:0),(ssn:'LCDCS';isi:7),
    (ssn:'LCDB2';isi:6),(ssn:'LCDMUX1';isi:5),(ssn:'LCDMUX0';isi:4),(ssn:'LCDPM2';isi:2),(ssn:'LCDPM1';isi:1),
    (ssn:'LCDPM0';isi:0),(ssn:'LCDEN';isi:7),(ssn:'LCDAB';isi:6),(ssn:'LCDIF';isi:4),(ssn:'LCDIE';isi:3),
    (ssn:'LCDBL';isi:0),(ssn:'EXCLK';isi:4),(ssn:'ADHSM';isi:7),(ssn:'ADRF';isi:5),(ssn:'OCR0';isi:60),
    (ssn:'I2CR';isi:54),(ssn:'UBRRH';isi:32),(ssn:'UCSRC';isi:32),(ssn:'I2DR';isi:3),(ssn:'I2AR';isi:2),
    (ssn:'I2SR';isi:1),(ssn:'I2BR';isi:0),(ssn:'SM2';isi:7),(ssn:'ISC2';isi:6),(ssn:'ADTS2';isi:7),(ssn:'ADTS1';isi:6),
    (ssn:'ADTS0';isi:5),(ssn:'URSEL';isi:7),(ssn:'SE';isi:7),(ssn:'SM2';isi:6),(ssn:'EIH';isi:5),(ssn:'RPDD';isi:7),
    (ssn:'RPDC';isi:6),(ssn:'RPDB';isi:5),(ssn:'RPDA';isi:4),(ssn:'TWI_TST';isi:1),(ssn:'SMALLBOOTSTART';isi:16128),
    (ssn:'SECONDBOOTSTART';isi:15872),(ssn:'THIRDBOOTSTART';isi:15360),(ssn:'LARGEBOOTSTART';isi:14336),
    (ssn:'BOOTSTART';isi:15360),(ssn:'PORTJ';isi:221),(ssn:'DDRJ';isi:220),(ssn:'PINJ';isi:219),(ssn:'PORTH';isi:218),
    (ssn:'DDRH';isi:217),(ssn:'PINH';isi:216),(ssn:'PCMSK3';isi:115),(ssn:'DDJ6';isi:6),(ssn:'DDJ5';isi:5),
    (ssn:'DDJ4';isi:4),(ssn:'DDJ3';isi:3),(ssn:'DDJ2';isi:2),(ssn:'DDJ1';isi:1),(ssn:'DDJ0';isi:0),(ssn:'DDH7';isi:7),
    (ssn:'DDH6';isi:6),(ssn:'DDH5';isi:5),(ssn:'DDH4';isi:4),(ssn:'DDH3';isi:3),(ssn:'DDH2';isi:2),(ssn:'DDH1';isi:1),
    (ssn:'DDH0';isi:0),(ssn:'UCSZ20';isi:2),(ssn:'PCINT30';isi:6),(ssn:'PCINT29';isi:5),(ssn:'PCINT28';isi:4),
    (ssn:'PCINT27';isi:3),(ssn:'PCINT26';isi:2),(ssn:'PCINT25';isi:1),(ssn:'PCINT24';isi:0),(ssn:'PSUSART0';isi:1),
    (ssn:'FOCDA';isi:7),(ssn:'WGMD1';isi:3),(ssn:'PCIE3';isi:7),(ssn:'PCIE2';isi:6),(ssn:'PCIF3';isi:7),
    (ssn:'PCIF2';isi:6),(ssn:'PCIF1';isi:5),(ssn:'PCIF0';isi:4),(ssn:'ADCSRB';isi:142),(ssn:'I2CR';isi:116),
    (ssn:'I2DR';isi:115),(ssn:'I2AR';isi:114),(ssn:'I2SR';isi:113),(ssn:'I2BR';isi:112),(ssn:'I2INT';isi:7),
    (ssn:'I2EA';isi:6),(ssn:'I2STA';isi:5),(ssn:'I2STO';isi:4),(ssn:'I2WC';isi:3),(ssn:'ENI2C';isi:2),
    (ssn:'I2EN';isi:2),(ssn:'I2C_TST';isi:1),(ssn:'I2IE';isi:0),(ssn:'I2S7';isi:7),(ssn:'I2S6';isi:6),
    (ssn:'I2S5';isi:5),(ssn:'I2S4';isi:4),(ssn:'I2S3';isi:3),(ssn:'I2GCE';isi:0),(ssn:'TWC_TST';isi:1),
    (ssn:'SMALLBOOTSTART';isi:32256),(ssn:'SECONDBOOTSTART';isi:31744),(ssn:'THIRDBOOTSTART';isi:30720),
    (ssn:'LARGEBOOTSTART';isi:28672),(ssn:'EEWEE';isi:2),(ssn:'TWS2';isi:2),(ssn:'TWS1';isi:1),(ssn:'TWS0';isi:0),
    (ssn:'BL_CONFIG';isi:53),(ssn:'B_DET';isi:52),(ssn:'PWR_CTL';isi:51),(ssn:'IO_DATIN';isi:50),(ssn:'IO_DATOUT';isi:49),
    (ssn:'IO_ENAB';isi:48),(ssn:'WDTCR';isi:34),(ssn:'BTCR';isi:33),(ssn:'BTCNT';isi:32),(ssn:'DEEAR';isi:30),
    (ssn:'DEEDR';isi:29),(ssn:'DEECR';isi:28),(ssn:'LOCKDET2';isi:23),(ssn:'VCOTUNE';isi:22),(ssn:'PWR_ATTEN';isi:20),
    (ssn:'TX_CNTL';isi:18),(ssn:'LOCKDET1';isi:16),(ssn:'SRAM_START';isi:96),(ssn:'SRAM_END';isi:223),
    (ssn:'BL';isi:7),(ssn:'BLV';isi:6),(ssn:'BL5';isi:5),(ssn:'BL4';isi:4),(ssn:'BL3';isi:3),(ssn:'BL2';isi:2),
    (ssn:'BL1';isi:1),(ssn:'BL0';isi:0),(ssn:'BD5';isi:5),(ssn:'BD4';isi:4),(ssn:'BD3';isi:3),(ssn:'BD2';isi:2),
    (ssn:'BD1';isi:1),(ssn:'BD0';isi:0),(ssn:'ACS2';isi:7),(ssn:'ACS1';isi:6),(ssn:'ACS0';isi:5),(ssn:'TM';isi:4),
    (ssn:'BD';isi:3),(ssn:'BLI';isi:2),(ssn:'SLEEP';isi:1),(ssn:'BBM';isi:0),(ssn:'IOI5';isi:5),(ssn:'IOI4';isi:4),
    (ssn:'IOI3';isi:3),(ssn:'IOI2';isi:2),(ssn:'IOI1';isi:1),(ssn:'IOI0';isi:0),(ssn:'IOO5';isi:5),(ssn:'IOO4';isi:4),
    (ssn:'IOO3';isi:3),(ssn:'IOO2';isi:2),(ssn:'IOO1';isi:1),(ssn:'IOO0';isi:0),(ssn:'BOHYST';isi:6),
    (ssn:'IOE5';isi:5),(ssn:'IOE4';isi:4),(ssn:'IOE3';isi:3),(ssn:'IOE2';isi:2),(ssn:'IOE1';isi:1),(ssn:'IOE0';isi:0),
    (ssn:'C9';isi:7),(ssn:'C8';isi:6),(ssn:'M1';isi:5),(ssn:'M0';isi:4),(ssn:'IE';isi:3),(ssn:'F2';isi:2),
    (ssn:'DATA';isi:1),(ssn:'F0';isi:0),(ssn:'C7';isi:7),(ssn:'C6';isi:6),(ssn:'C5';isi:5),(ssn:'C4';isi:4),
    (ssn:'C3';isi:3),(ssn:'C2';isi:2),(ssn:'C1';isi:1),(ssn:'C0';isi:0),(ssn:'ED7';isi:7),(ssn:'ED6';isi:6),
    (ssn:'ED5';isi:5),(ssn:'ED4';isi:4),(ssn:'ED3';isi:3),(ssn:'ED2';isi:2),(ssn:'ED1';isi:1),(ssn:'ED0';isi:0),
    (ssn:'BSY';isi:3),(ssn:'EEU';isi:2),(ssn:'EEL';isi:1),(ssn:'EER';isi:0),(ssn:'EUD';isi:7),(ssn:'LAT';isi:6),
    (ssn:'ULC2';isi:5),(ssn:'ULC1';isi:4),(ssn:'ULC0';isi:3),(ssn:'LC2';isi:2),(ssn:'LC1';isi:1),(ssn:'LC0';isi:0),
    (ssn:'VCOVDET1';isi:7),(ssn:'VCOVDET0';isi:6),(ssn:'VCOTUNE4';isi:4),(ssn:'VCOTUNE3';isi:3),(ssn:'VCOTUNE2';isi:2),
    (ssn:'VCOTUNE1';isi:1),(ssn:'VCOTUNE0';isi:0),(ssn:'PCC2';isi:5),(ssn:'PCC1';isi:4),(ssn:'PCC0';isi:3),
    (ssn:'PCF2';isi:2),(ssn:'PCF1';isi:1),(ssn:'PCF0';isi:0),(ssn:'FSK';isi:6),(ssn:'TXE';isi:5),(ssn:'TXK';isi:4),
    (ssn:'LOC';isi:2),(ssn:'UPOK';isi:4),(ssn:'ENKO';isi:3),(ssn:'BOD';isi:2),(ssn:'CS1';isi:1),(ssn:'CS0';isi:0));

  aSymbolList:Array[1..nDevices] Of AnsiString = (
  { Symbols for AT90S1200 device }
    '.....................................................................................',
  { Symbols for AT90S2313 device }
    '....................................................................................................'+
    '.............................................',
  { Symbols for AT90S2323 device }
    '..............    ................   .....   .....   .....                           ..        .    '+
    '          .                  ..              ...',
  { Symbols for AT90S2333 device }
    '..................................  ......  ......  .......................................     .  .'+
    '        ....  . ...  ...............................................................................'+
    '....................',
  { Symbols for AT90S2343 device }
    '..............    ................   .....   .....   .....                           ..        .    '+
    '          .                  ..              ...',
  { Symbols for AT90S4414 device }
    '........ ...........................................................................................'+
    '        ..... ...............................        ......           .    ..........              .'+
    '...............................................................',
  { Symbols for AT90S4433 device }
    '..................................  ......  ......  .......................................     .  .'+
    '        ....  . ...  ...............................................................................'+
    '....................',
  { Symbols for AT90S4434 device }
    '........ ..........    ......................................................................  .....'+
    '        ...      ...............................   ........   ....        ...........   ............'+
    '..........................    .. ...............................................................',
  { Symbols for AT90S8515 device }
    '........ ...........................................................................................'+
    '        ..... ...............................        ......           .    ..........              .'+
    '................................ ..............................    .',
  { Symbols for AT90C8534 device }
    '.......  ..       .      ...    ..                                                   ..  ..    .    '+
    '        ...               ... .                               ....        .             ........... '+
    '                    .  ..         ....... .......                  .     ..     ...             ....'+
    '...',
  { Symbols for AT90S8535 device }
    '........ ..........    ......................................................................  .....'+
    '        ...      ...............................   ........   ....        ...........   ............'+
    '..........................    .. ...............................................................',
  { Symbols for ATTINY11 device }
    '........   ...   ...............     .....   .....  ......                     ...... .             '+
    '          .                  .               ...                                                    '+
    '                                                                                                    '+
    '   ..',
  { Symbols for ATTINY12 device }
    '..............   .................   .....  ......  ......                     ...... .             '+
    '          .                   .              ...                   ..     .           .             '+
    '                                .                                                                   '+
    '   ............',
  { Symbols for ATTINY13 device }
    '..  . ........   ..... ...........          ......  ......                     ........             '+
    '          .                   .              ...              . .. ..     .              .... ..... '+
    '                                                                                                    '+
    '   ....        .........................................................................',
  { Symbols for ATTINY15 device }
    '..............   .................   .....  ......  ......                     ........             '+
    '          .               .....              ...              .... ... .  .             ........... '+
    '                                                                         .      .                   '+
    '   ....                               ..                                         ..     ............'+
    '...',
  { Symbols for ATTINY22 device }
    '..............    ................   .....   .....   .....                           ..        .    '+
    '          .                  ..              ...',
  { Symbols for ATTINY25 device }
    '..... .. .....   ..... ...........          ......  ......                     ........        .    '+
    '          . .  .          ... .              ...              . .. ..     .             ..... ..... '+
    '                          ..  ..                                   .     .      .                   '+
    '   ....          . .    ...... . ................. ........................................  . ... .'+
    '.........................................................................',
  { Symbols for ATTINY26 device }
    '..............   ..... ...................................                     ...... .             '+
    '          . .  .   ..     ... .              ....             .... ..     .             ........... '+
    '                       .....  .. ........................                .      .                   '+
    '    ...                               ..                   .  ......            ...          .   . .'+
    '                   ...      ...                       ............... .  ...........................'+
    '.............',
  { Symbols for ATTINY28 device }
    '.            ......  ...........                  ...................................               '+
    '        ...      ..          .                ..                   .                                '+
    '                 ...   . .           ....    . ..    . ..                                           '+
    '       ........                                                                                     '+
    '                                                                                                    '+
    '             .........................',
  { Symbols for ATTINY45 device }
    '..... .. .....   ..... ...........          ......  ......                     ........        .    '+
    '          . .  .          ... .              ...              . .. ..     .             ..... ..... '+
    '                          ..  ..                                   .     .      .                   '+
    '   ....          . .    ...... . ................. ........................................  . ... .'+
    '.........................................................................',
  { Symbols for ATTINY85 device }
    '..... .. .....   ..... ...........          ......  ......                     ........        .    '+
    '          . .  .          ... .              ...              . .. ..     .             ..... ..... '+
    '                    .     ..  ..                                   .     .      .                   '+
    '   ....          . .    ...... . ................. ........................................  . ... .'+
    '.........................................................................',
  { Symbols for ATTINY2313 device }
    '..... ................ ......... .        ................       ..................... ..........   '+
    '............. .......  .. ...  .... ..... ......           ...     ..     .          .              '+
    '                     .......  ..              ...     ...                           .               '+
    '   ...  .......  . .    .        .....  ......... ......  ................     ..                   '+
    '                   ...                                ...............                        .......'+
    '     ......                           ...................................................',
  { Symbols for ATMEGA103 device }
    '.   .... .........   .   ............................................................. ......  .....'+
    '                   .............................   ...  ...   ....        ...........   ............'+
    '.....            .........  .... ..........................    ... ...............   .......        '+
    '                                      ..                                                            '+
    '                                                                                                    '+
    '                                                                                         ...........'+
    '.........................................................................',
  { Symbols for ATMEGA104 device }
    '.   .... .........   . ............................................................... ......  .    '+
    '                 ........ ......... ..... ... ..   ........   .... ..     ............  ............'+
    '..........................  . .. ................................. ...............   .......        '+
    '                                   .....         .         .  ......            ...                .'+
    '                                                                      .                             '+
    '..........  .                                            .......       ....... ......... .. ..... ..'+
    '.. .................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................',
  { Symbols for ATMEGA1280 device }
    '.   .                  ......... .                ........              ..............              '+
    '........         ....  .. ...               . ..                   ..     ...........   ..... ..... '+
    '           ......  ..       . ..                 ........    ..           .  .   .       ...        '+
    '                 .                 ...  .......... .....  ................  .  .........           .'+
    '        .                                        .  .                 .                             '+
    '..........  .                            .         ..  ........... . . ......           . .         '+
    '  .        ....................                          ................                           '+
    '                   .         .......   .....  ... .......        ........      .      ..  . ......  '+
    '....  ........ ................................ ....   ....  ...............................        '+
    '........                  .....     ................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '...........',
  { Symbols for ATMEGA1281 device }
    '.   .                  ......... .                ........              ..............              '+
    '........         ....  .. ...               . ..                   ..     ...........   ..... ..... '+
    '           ......  ..       . ..                 ........    ..           .  .   .       ...        '+
    '                 .                 ...  .......... .....  ................  .  .........           .'+
    '        .                                        .  .                 .                             '+
    '..........  .                            .         ..  ........... . . ......           . .         '+
    '  .        ....................                          ................                           '+
    '                   .         .......   .....  ... .......        ........      .      ..  . ......  '+
    '....  ........ ................................ ....   ....  ...............................        '+
    '........                  .....     ................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '...........',
  { Symbols for ATMEGA128 device }
    '.   .... .........   . ............................................................... ......  .    '+
    '                 ........ ......... ..... ... ..   ........   .... ..     ............  ............'+
    '..........................  . .. ................................. ...............    .. ...        '+
    '                                   .....         .         .  ......            ...                .'+
    '                                                                      .                             '+
    '..........  .                                            .......       ....... ......... .. ..... ..'+
    '.. .............................. .. ...............................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................                                                                '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                         .........  '+
    '                                                                                                    '+
    '                                                                                                    '+
    '           ....',
  { Symbols for ATMEGA161 device }
    '........ ...........................................................................................'+
    '        ..... ............... ................       ......           .   ........... .            .'+
    '...............................................................    .                 ...........    '+
    '                                   ....           .                                                 '+
    '                                                                                        ..          '+
    '                                                                               .                .   '+
    '                                 ....         ...     ...     ...                                   '+
    '                       ... .     ......         .                                    .     .        '+
    '               ....  ......  ....... ....... ..              .                                      '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '               ....................................',
  { Symbols for ATMEGA162 device }
    '........ .........................        ................       ...................................'+
    '        ..... ..................................     ......        .. .   ........... .             '+
    '     ............ ..............         ................  ....    .                 ...........    '+
    '                                   ....          .......   .  ............      .                   '+
    '  .                                                                                     ..          '+
    '..........                                               .........     ....    ..               .   '+
    '                                 ....                 ...     ...                 ........  ....    '+
    '                   .   ..... ..........    ......          . .           ....  ....  .  .. .....    '+
    '....  .....    ..... ....... .................................             .........     ...        '+
    '                                                                                                    '+
    '                                                     ..      .                                      '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                    ........        '+
    '                                                                                                    '+
    '           ......................  .  .............................................',
  { Symbols for ATMEGA163 device }
    '........ ..........    ......................................................................  .....'+
    '        ...      ...............................   .......... .... ..     ............  ............'+
    '..........................    .. ...............................................................    '+
    '     .                             ...            .                             ...                .'+
    '                                                                      .                 ..          '+
    '            .                                                                  .                    '+
    '                                                                                                    '+
    '                                            ..  .         ..                               .        '+
    '                                                             ........     .                         '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '               . .    .                  .        .   .                       ..........',
  { Symbols for ATMEGA165 device }
    '.   .                  ...........                ........              ..............              '+
    '........           ..  .. ... ..... ..... ... ..                   ..     ............  ..... ..... '+
    '           ......  ..         ..                 ........    ..           .  .   .       ...        '+
    '                 .                 ...  .        .......   .  ............  .  .........           .'+
    '                                                 .  . ............... .                             '+
    '........... .                            .               .........     ..................           '+
    '                  .                                      ................                           '+
    '                   .         ....          .  ...........           .                               '+
    '                                                             .             .................        '+
    '........                  .....                                                            . .. .   '+
    '                         ............. .....     ... .. . .  .  .. ........ ........    ............'+
    '............                                                                                        '+
    '                                                                                                    '+
    '     .                          .......                             ... ....        ........        '+
    '    ..     ...   .....                     .. .... ..... ..... .....................................'+
    '...............                          .                                              ............'+
    '........',
  { Symbols for ATMEGA168 device }
    '.   .                  ......... .        ................       .....................              '+
    '........         ....  .. ...               ....                   ..     ...........   ..... ..... '+
    '     ............ ...         ..                            . .           .  .   .       ...        '+
    '                                    .   .......... .....  ................  .  .........           .'+
    '        .                                        .  .                 .                             '+
    '        ..                               .         ..  ........... . . ......           .           '+
    '                 ..                                                                                 '+
    '                   .         ..            .  ...                  ..                               '+
    '               ........        ........         .. ...       .............. ........                '+
    '                                                                                     ............   '+
    '                         . .........   .....     ...... ...  .. . ............... ...   ...         '+
    '.........                                                                                           '+
    '                                                                              ..  ..................'+
    '..............                    .....                            .... ............ ..........     '+
    ' .....     ...   ..... .....              ... ....                                                  '+
    '               .                                                                                 .  '+
    '        .......................',
  { Symbols for ATMEGA169 device }
    '.   .                  ...........        ................       .....................              '+
    '........           ..  .. ... .             ....                   ..     ...........   ..... ..... '+
    '     ............ ...         ..         ................  ....           .  .   .       .......    '+
    '                 .                 ...  .        .......   .  ............  .  .... ....           .'+
    '  .                                                   ............... .                             '+
    '........... .                            .               .........     ......           .           '+
    '                  .                              ........................                           '+
    '                             ....          .  ...........    .      .                 ..   .        '+
    '               ..... ..        ........        .......       .             .................        '+
    '................     ..........                                                ......      . .. .   '+
    '                         . ........... .....     ... .. . .  .  .. ........ ........    ............'+
    '............                                                                                        '+
    '                                                                                                    '+
    '                                .......                             ... ....        ........        '+
    '      ........   .....                     .. ..........      .                                     '+
    '           ....                          .        .                       .   .....           ... ..'+
    '.........      ........        .....................................................................'+
    '.',
  { Symbols for ATMEGA16 device }
    '........ ..........    ......................................................................  .....'+
    '        ...      ...............................   ............... ..     ............  ............'+
    '..........................    .. ...............................................................    '+
    '     .                     .       ...            .                             ....               .'+
    '                                                                      .                 ..          '+
    '            .                                                          ....  . .........            '+
    '                               ......                                                               '+
    '                   .         ..            ...  .        ...                         .  .. .        '+
    '              .                                              ........     .                         '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '           ..... .    .        ..        .        .   .                       ..........            '+
    '                                                                                                    '+
    ' ..............',
  { Symbols for ATMEGA2560 device }
    '.   .                  ......... .                ........              ..............              '+
    '........         ....  .. ...               . ..                   ..     ...........   ..... ..... '+
    '           ......  ..       . ..                 ........    ..           .  .   .       ...        '+
    '                 .                 ...  .......... .....  ................  .  .........           .'+
    '        .                                        .  .                 .                             '+
    '..........  .                            .         ..  ........... . . ......           . .         '+
    '  .        ....................                          ................                           '+
    '                   .         .......   .....  ... .......        ........      .      ..  . ......  '+
    '....  ........ ................................ ....   ....  ...............................        '+
    '........                  .....     ................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '...........',
  { Symbols for ATMEGA2561 device }
    '.   .                  ......... .                ........              ..............              '+
    '........         ....  .. ...               . ..                   ..     ...........   ..... ..... '+
    '           ......  ..       . ..                 ........    ..           .  .   .       ...        '+
    '                 .                 ...  .......... .....  ................  .  .........           .'+
    '        .                                        .  .                 .                             '+
    '..........  .                            .         ..  ........... . . ......           . .         '+
    '  .        ....................                          ................                           '+
    '                   .         .......   .....  ... .......        ........      .      ..  . ......  '+
    '....  ........ ................................ ....   ....  ...............................        '+
    '........                  .....     ................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '...........',
  { Symbols for ATMEGA323 device }
    '........ ..........    ......................................................................  ..   '+
    '        ...      ...............................   ............... ..     ............  ............'+
    '..........................    .. ................................................. .............    '+
    '     .                             ...            .                             ...                .'+
    '                                                                      .                 ..          '+
    '            .                                                                . .........            '+
    '                               ......                                                               '+
    '                   .         ....          ...  .         ..                         .  .. .        '+
    '              .                                              ........     .                         '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '               . .             ..        .            .                           ......            '+
    '                                                                                                    '+
    ' . ..     .   ..............',
  { Symbols for ATMEGA3250 device }
    '.   .                  ...........        ................       .....................              '+
    '                   ..  .. ... .             ....                   ..     . ........    ..... ..... '+
    '     ............ ...         ..         ................  ....           .  .   .       .......    '+
    '                 .                 ...           .......   .  ............  .  .........           .'+
    '                                                 .  . ............... .         ..                  '+
    '........... .                            .               .........     ......           .           '+
    '                  .                              ........................                           '+
    '                   .         ....          .  ...........           .                               '+
    '               ........        ..... ..        .......                     .................        '+
    '................     ..........                                                ......      . .. .   '+
    '                         . ........... .....     ...... . .  .  .. ........ ........    ............'+
    '............                                                                                        '+
    '   .......         ...............        ........                                                  '+
    '     .                          .......                             ... ....................        '+
    '    .            ......                    .. .... .....      .                                     '+
    '           . ..                          .                                                    ......'+
    '. ..    .      ........                                                                           . '+
    '                            .......................................',
  { Symbols for ATMEGA325 device }
    '.   .                  ...........        ................       .....................              '+
    '                   ..  .. ... .             ....                   ..     . ........    ..... ..... '+
    '     ............ ...         ..         ................  ....           .  .   .       .......    '+
    '                 .                 ...           .......   .  ............  .  .........           .'+
    '                                                 .  . ............... .         ..                  '+
    '........... .                            .               .........     ......           .           '+
    '                  .                              ........................                           '+
    '                   .         ....          .  ...........           .                               '+
    '               ........        ..... ..        .......                     .................        '+
    '................     ..........                                                ......      . .. .   '+
    '                         . ........... .....     ...... . .  .  .. ........ ........    ............'+
    '............                                                                                        '+
    '   .......         ...............        ........                                                  '+
    '     .                          .......                             ... ....................        '+
    '    .            ......                    .. .... .....      .                                     '+
    '           . ..                          .                                                    ......'+
    '. ..    .      ........                                                                           . '+
    '                            .......................................',
  { Symbols for ATMEGA32 device }
    '........ ..........    ......................................................................  ..   '+
    '        ...      ...............................   ............... ..     ............  ............'+
    '..........................    .. ................................................. .............    '+
    '     .                             ...            .                             ...                .'+
    '                                                                      .                 ..          '+
    '            .                                                                . .........            '+
    '                               ......                                                               '+
    '                   .         ....          ...  .         ..                         .  .. .        '+
    '              .                                              ........     .                         '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '               . .             ..        .            .                           ......            '+
    '                                                                                                    '+
    ' . ..     .   ..............',
  { Symbols for ATMEGA48 device }
    '.   .                  ......... .        ................       .....................              '+
    '........         ....  .. ...               ....                   ..     ...........   ..... ..... '+
    '     ............ ...         ..                            . .           .  .   .       ...        '+
    '                                    .   .......... .....  ................  .  .........           .'+
    '        .                                        .  .                 .                             '+
    '        ..                               .         ..  ........... . . ......           .           '+
    '                 ..                                                                                 '+
    '                   .         ..            .    .                  ..                               '+
    '               ........        ........         .. ...       .............. ........                '+
    '                                                                                     ............   '+
    '                         . .........   .....     ...... ...  .. . ............... ...   ...         '+
    '.........                                                                                           '+
    '                                                                              ..  ..................'+
    '..............                    .....                            .... ............ ..........     '+
    ' .....      ..   ..... .....              ... ....                                                  '+
    '               .                                                                                 .  '+
    '        .......................',
  { Symbols for ATMEGA603 device }
    '.   .... .........   .   ............................................................. ......  .....'+
    '                   .............................   ...  ...   ....        ...........   ............'+
    '.....            .........  .... ..........................    ... ...............   .......        '+
    '                                      ..                                                            '+
    '                                                                                                    '+
    '                                                                                         ...........'+
    '.........................................................................',
  { Symbols for ATMEGA640 device }
    '.   .                  ......... .                ........              ..............              '+
    '........         ....  .. ...               . ..                   ..     ...........   ..... ..... '+
    '           ......  ..       . ..                 ........    ..           .  .   .       ...        '+
    '                 .                 ...  .......... .....  ................  .  .........           .'+
    '        .                                        .  .                 .                             '+
    '..........  .                            .         ..  ........... . . ......           . .         '+
    '  .        ....................                          ................                           '+
    '                   .         .......   .....  ... .......        ........      .      ..  . ......  '+
    '....  ........ ................................ ....   ....  ...............................        '+
    '........                  .....     ................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '...........',
  { Symbols for ATMEGA6450 device }
    '.   .                  ...........        ................       .....................              '+
    '                   ..  .. ... .             ....                   ..     . ........    ..... ..... '+
    '     ............ ...         ..         ................  ....           .  .   .       .......    '+
    '                 .                 ...           .......   .  ............  .  .........           .'+
    '                                                 .  . ............... .         ..                  '+
    '........... .                            .               .........     ......           .           '+
    '                  .                              ........................                           '+
    '                   .         ....          .  ...........           .                               '+
    '               ........        ..... ..        .......                     .................        '+
    '................     ..........                                                ......      . .. .   '+
    '                         . ........... .....     ...... . .  .  .. ........ ........    ............'+
    '............                                                                                        '+
    '   .......         ...............        ........                                                  '+
    '     .                          .......                             ... ....................        '+
    '    .            ......                    .. .... .....      .                                     '+
    '           . ..                          .                                                    ......'+
    '. ..    .      ........                                                                           . '+
    '                            .......................................',
  { Symbols for ATMEGA645 device }
    '.   .                  ...........        ................       .....................              '+
    '                   ..  .. ... .             ....                   ..     . ........    ..... ..... '+
    '     ............ ...         ..         ................  ....           .  .   .       .......    '+
    '                 .                 ...           .......   .  ............  .  .........           .'+
    '                                                 .  . ............... .         ..                  '+
    '........... .                            .               .........     ......           .           '+
    '                  .                              ........................                           '+
    '                   .         ....          .  ...........           .                               '+
    '               ........        ..... ..        .......                     .................        '+
    '................     ..........                                                ......      . .. .   '+
    '                         . ........... .....     ...... . .  .  .. ........ ........    ............'+
    '............                                                                                        '+
    '   .......         ...............        ........                                                  '+
    '     .                          .......                             ... ....................        '+
    '    .            ......                    .. .... .....      .                                     '+
    '           . ..                          .                                                    ......'+
    '. ..    .      ........                                                                           . '+
    '                            .......................................',
  { Symbols for ATMEGA64 device }
    '.   .... .........   . ............................................................... ......  .    '+
    '                 ........ ......... ..... ... ..   ........   .... ..     ............  ............'+
    '..........................  . .. ................................. ...............   .......        '+
    '                           .       .....         .         .  ......            .... ...           .'+
    '                                                                      .                             '+
    '..........  .                                            .......       ....... ......... .  ..... ..'+
    '.. .................................................................................................'+
    '....................................................................................................'+
    '....................................................................................................'+
    '...............................    .                                                                '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                         .........  '+
    '                                                                                                    '+
    '                                                                                                    '+
    '           ....                                                                                     '+
    '                                                                                                    '+
    '                                                                   ..........................',
  { Symbols for ATMEGA83 device }
    '........ ..........    ......................................................................  .....'+
    '        ...      ...............................   .......... .... ..     ............  ............'+
    '..........................    .. ...............................................................    '+
    '     .                             ...            .                             ...                .'+
    '                                                                      .                 ..          '+
    '            .                                                                  .                    '+
    '                                                                                                    '+
    '                                                .         ..                               .        '+
    '                                                             ..............                         '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                         .......    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '               . .    .                  .        .                           ..........            '+
    '                                                                                                    '+
    '                      .',
  { Symbols for ATMEGA8515 device }
    '........ ........................................................................................  .'+
    '        ..... ........... ......................     .........     .. .   .............            .'+
    '................................ ..............................    .                                '+
    '                                   ....          ..        .                    .                   '+
    '                                                                                        ..          '+
    '                                                                       ....  ...........        .   '+
    '                                  ..          ...     ...     ...                                   '+
    '                   .       . ..  ......    ......          .                         .  ..          '+
    '              .                                              .                                      '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '           ..  ...      ...    ..  .  ...             .  .           .....                          '+
    '                         ......                                                                     '+
    '   ..         .                                                                              .',
  { Symbols for ATMEGA8535 device }
    '........ ..........    ......................................................................  ..   '+
    '        ...      ...............................   ............ .. ..     ............  ............'+
    '..........................    .. ...............................................................    '+
    '     .                     .       ...            .        .                    ....               .'+
    '                                                                      .                 ..          '+
    '            .                                                          ....  ...........            '+
    '                               ......                                                               '+
    '                   .         ..            .  ...        ...                         .  .. .        '+
    '              .                                              ..............                         '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                         .......    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '           ..... .             ..        .            .                            .....            '+
    '                         ......                                                                     '+
    ' ..............       .                                                  .........     .      ...',
  { Symbols for ATMEGA88 device }
    '.   .                  ......... .        ................       .....................              '+
    '........         ....  .. ...               ....                   ..     ...........   ..... ..... '+
    '     ............ ...         ..                            . .           .  .   .       ...        '+
    '                                    .   .......... .....  ................  .  .........           .'+
    '        .                                        .  .                 .                             '+
    '        ..                               .         ..  ........... . . ......           .           '+
    '                 ..                                                                                 '+
    '                   .         ..            .  ...                  ..                               '+
    '               ........        ........         .. ...       .............. ........                '+
    '                                                                                     ............   '+
    '                         . .........   .....     ...... ...  .. . ............... ...   ...         '+
    '.........                                                                                           '+
    '                                                                              ..  ..................'+
    '..............                    .....                            .... ............ ..........     '+
    ' .....     ...   ..... .....              ... ....                                                  '+
    '               .                                                                                 .  '+
    '        .......................',
  { Symbols for ATMEGA8 device }
    '........ ..........    ......................................................................  ..   '+
    '        ...      ...............................   ............... ..     ............  ............'+
    '.......................       ..                          . . .................... .............    '+
    '     .                             ...            .        .                    ...                .'+
    '                                                                      .                 ..          '+
    '                                                                       ....  ...........            '+
    '                                                                                                    '+
    '                   .         ..            .  ...        ...                            .. .        '+
    '              .                                              ..............                         '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                         .........  '+
    '                                                                                                    '+
    '                                                                                                    '+
    '             ... .                       .            .                            .....            '+
    '                         ......                                                                     '+
    '  .......     ...',
  { Symbols for AT86RF401 device }
    '.                           ....                                                     .              '+
    '                             .                                                                      '+
    '                    .             .......                                                           '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '                                                                                                    '+
    '               ........                                                                             '+
    '                                                                                                 ...'+
    '....................................................................................................'+
    '...............');

  aRegisters:Array[1..6] Of TRegister = (
    (srn:'ZL';iri:30),(srn:'ZH';iri:31),(srn:'XL';iri:26),(srn:'XH';iri:27),(srn:'YL';iri:28),(srn:'YH';iri:29));

  aRegList:Array[1..nDevices] Of String[6] = (
    { AT90S1200: }'..    ',{ AT90S2313: }'......',{ AT90S2323: }'......',{ AT90S2333: }'......',{ AT90S2343: }'......',
    { AT90S4414: }'......',{ AT90S4433: }'......',{ AT90S4434: }'......',{ AT90S8515: }'......',{ AT90C8534: }'......',
    { AT90S8535: }'......',{ ATTINY11: }'..    ',{ ATTINY12: }'..    ',{ ATTINY13: }'......',{ ATTINY15: }'..    ',
    { ATTINY22: }'......',{ ATTINY25: }'......',{ ATTINY26: }'......',{ ATTINY28: }'..    ',{ ATTINY45: }'......',
    { ATTINY85: }'......',{ ATTINY2313: }'......',{ ATMEGA103: }'......',{ ATMEGA104: }'......',{ ATMEGA1280: }'......',
    { ATMEGA1281: }'......',{ ATMEGA128: }'......',{ ATMEGA161: }'......',{ ATMEGA162: }'......',{ ATMEGA163: }'......',
    { ATMEGA165: }'......',{ ATMEGA168: }'......',{ ATMEGA169: }'......',{ ATMEGA16: }'......',{ ATMEGA2560: }'......',
    { ATMEGA2561: }'......',{ ATMEGA323: }'......',{ ATMEGA3250: }'......',{ ATMEGA325: }'......',{ ATMEGA32: }'......',
    { ATMEGA48: }'......',{ ATMEGA603: }'......',{ ATMEGA640: }'......',{ ATMEGA6450: }'......',{ ATMEGA645: }'......',
    { ATMEGA64: }'......',{ ATMEGA83: }'......',{ ATMEGA8515: }'......',{ ATMEGA8535: }'......',{ ATMEGA88: }'......',
    { ATMEGA8: }'......',{ AT86RF401: }'......');

Function DefIntVectors(b:Byte):Integer;
Var i,k,l:LongInt;
    sn,sv:String;
    f:Boolean;
Begin
DefIntVectors:=0;
k:=0;
f:=False;
sn:='';
sv:='';
While (DefIntVectors=0) And (k<Length(aIntVec[b])) Do
  Begin
  Inc(k);
  Case aIntVec[b,k] Of
    '=':f:=True;
    ';':Begin
      Val(sv,i,l);
      If Not AddSymbol('C',sn+'ADDR',True,i) Then DefIntVectors:=-3;
      sn:='';
      sv:='';
      f:=False;
      End;
    Else
    If f Then sv:=sv+aIntVec[b,k] Else sn:=sn+aIntVec[b,k];
    End;
  End;
If DefIntVectors=0 Then
  Begin
  Val(sv,i,l);
  If Not AddSymbol('C',sn+'ADDR',True,i) Then DefIntVectors:=-3;
  End;
End;

Function DefSymbols(b:Byte):Integer;
Var k:LongInt;
Begin
DefSymbols:=0;
k:=1;
While (DefSymbols=0) And (k<=Length(aSymbolList[b])) Do
  Begin
  If (aSymbolList[b,k]='.') And (Not AddSymbol('C',aSymbols[k].ssn,True,aSymbols[k].isi)) Then DefSymbols:=-4;
  Inc(k);
  End;
End;

Function DefRegisters(b:Byte):Integer;
Var k:Byte;
Begin
DefRegisters:=0;
k:=1;
While (DefRegisters=0) And (k<=Length(aRegList[b])) Do
  Begin
  If (aRegList[b,k]='.') And (Not AddSymbol('R',aRegisters[k].srn,True,aRegisters[k].iri)) Then DefRegisters:=-5;
  Inc(k);
  End;
End;

Function DefDevice(sDevice:String):Integer;
Var b:Byte;
    sd:String;
Begin
sd:=UpperCase(sDevice);
b:=0;
Repeat Inc(b) Until (b>nDevices) Or (aDevices[b].sdn=sd);
If b>nDevices Then
  DefDevice:=-1 { Unknown device } Else With aDevices[b] Do
  Begin
  If FindSymbolFirst('T')<>NIL Then
    DefDevice:=-6 Else
    Begin
    If AddSymbol('T',sdn,True,idf*2) Then
      Begin
      fWithinDefInclude:=True;
      If ((idr=-1) Or AddSymbol('C','RAMEND',True,idr)) And
         ((idx=-1) Or AddSymbol('C','XRAMEND',True,idx)) And
         ((ide=-1) Or AddSymbol('C','E2END',True,ide)) And
         ((idp=-1) Or AddSymbol('C','EEPROMEND',True,idp)) And
         ((idf=-1) Or AddSymbol('C','FLASHEND',True,idf)) Then
        Begin
        DefDevice:=DefIntVectors(b);
        If DefDevice=0 Then DefDevice:=DefSymbols(b);
        If DefDevice=0 Then DefDevice:=DefRegisters(b);
        If DefDevice=0 Then
          Begin
          device.sn:=sdn;
          If Not GetAvrType Then DefDevice:=-2;
          If Not SetInstType(UpperCase(sdn)) Then DefDevice:=-2;
          End;
        End Else
        DefDevice:=-2;
      fWithinDefInclude:=False;
      End Else
      DefDevice:=-2;
    End;
  End;
End;

Function InclDevice(sInclFile:String):Integer;
Var s:String;
  b:Byte;
Begin
InclDevice:=-7;
s:=Uppercase(sInclFile);
b:=Pos('DEF.INC',s);
If b>0 Then
  Begin
  s:=Copy(s,1,b-1);
  b:=Length(s)+1;
  Repeat Dec(b) Until (b=0) Or (s[b]='\') Or (s[b]='/');
  If b>0 Then s:=Copy(s,b+1,255);
  b:=0;
  Repeat Inc(b) Until (b>nDevices) Or (aDevices[b].sif=s);
  If b<=nDevices Then
    InclDevice:=DefDevice(aDevices[b].sdn);
  End;
End;

Begin
End.

